<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

session_start();

$title='acls';
$singtitle='acl';
require("/etc/nuface/config.php");
require("include/messages.php");
$header_onclick="return ask_list_change(new Array('sortcat'),'$gal_confirm_change_order')";
require("include/headers.php");
require("include/function.php");
require("include/types.php");

$expolicy=unserialize($_SESSION['document']);
if ((!isset($expolicy)) or ($expolicy=='')){
  add_log($gal_load_valid_xml_file);
  log_and_exit(-1);
}

$acls=&$expolicy->acls;
$protocols=$expolicy->protocols;
$groups=&$expolicy->groups;
$subjects=$expolicy->subjects;
$applications=$expolicy->applications;
$ressources=$expolicy->ressources;


$new_name=$_REQUEST['name'];
$new_acl=$_REQUEST['new_acl'];
$new_group=$_REQUEST['new_group'];
$delete=$_REQUEST['delete'];
$ch_name=$_REQUEST['ch_name'];
$ch_protocol=$_REQUEST['protocol'];
$ch_group=$_REQUEST['group'];
$ch_application=$_REQUEST['application'];
$ch_subject=$_REQUEST['subject'];
$ch_ressource=$_REQUEST['ressource'];
$ch_decision=$_REQUEST['decision'];
$ch_acl=$_REQUEST['acl'];
$macl=$_REQUEST['macl'];
$up=$_REQUEST['up'];
$down=$_REQUEST['down'];
$aclorder=$_REQUEST['dndSort'];
$ch_comment=$_REQUEST['comment'];
$gr_enabled=$_REQUEST['gr_enabled'];
$modify_groups=$_REQUEST['modify_groups'];
$del_grp_id = $_REQUEST['del_grp'];

#INPUT STRICT CHECKING
if (!check_name($new_name))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_protocol))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_group))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_application))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_subject))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_nb($ch_ressource))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_decision($ch_decision))
{
    add_log($gal_elt_not_exists." no decision $ch_decision");
    log_and_exit(-1);
}

if (!check_nb($ch_acl))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}

if (!check_aclorder($aclorder))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}





print_js_groups_tab($groups);

/* set is_used field for groups */
foreach($acls->ordered_list_tab() as $key => $foo){
    $myacl = $acls->get_elt($key);
    foreach ($groups->list_tab() as $keyg=>$foog){
        $group=$groups->get_elt($keyg);
        if($myacl->group == $group->ID){
            $group->is_used = true;
        }else{
            $group->is_used = false;
        }
        $groupc = $group->cloneobj();
        $groups->del_elt($group->ID);
        $groups->add_elt($groupc);
    }
}

if ((isset($down)) and ($down==1))
  $up=-1;

if ((isset($new_name) and (isset($new_acl)) and ($new_acl==1)))
{
  $new_acl=array();
  $new_acl{'name'}=$new_name;
  $new_acl{'modified'}=date("D d M Y");
  $acl=new acl($new_acl,'data',$acls->new_id());
  $acls->add_elt($acl);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}
else if (isset($modify_groups) and $modify_groups==1)
{
  $modified=0;
    foreach ($groups->list_tab() as $key=>$foo)
    {
      $local_mod=0;
      $received=array();
      $group=$groups->get_elt($key);
      if (isset($_REQUEST["enabled".$key]) and $_REQUEST["enabled".$key]=='on')
        $received['enabled']=1;
      else
        $received['enabled']=0;
      if (isset($_REQUEST["name".$key]) and check_name($_REQUEST["name".$key]))
        $received['name']=$_REQUEST["name".$key];
      else
        $received['name']=$key;
      if (isset($_REQUEST["comment".$key]) and check_comment($_REQUEST["comment".$key]))
        $received['comment']=$_REQUEST["comment".$key];
      else
        $received['comment']="";

      if ($received['enabled'] != $group->enabled)
        $local_mod++;
      if ($received['name'] != $group->name)
        $local_mod++;
      if ($received['comment'] != $group->comment)
        $local_mod++;
      $grp_deleted = false;
      if($_REQUEST['del_grp'][$group->ID] == 'on' && !$group->is_used){/* delete group if checkbox is checked */
          $groups->del_elt($group->ID);
          $grp_deleted = true;
          $modified++;
      }
      if ($local_mod>0 && !$grp_deleted)
      {
        $groups->del_elt($group->ID);
        $new_grp=new group($received,'data',$group->ID);
        $groups->add_elt($new_grp);
        $modified++;
      }
    }
  if ($modified>0)
  {
    $_SESSION['document']=serialize($expolicy);
    $_SESSION['modified']=1;
  }
}  
else if ((isset($new_name) and (isset($new_group)) and ($new_group==1)))
{
  $new_group=array();
  $new_group{'name'}=$new_name;
  $new_group{'modified'}=date("D d M Y");
  $group=new group($new_group,'data',$groups->new_id());
  $groups->add_elt($group);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}elseif (isset($ch_acl) and isset ($ch_group) and isset($ch_protocol) and isset($ch_application) and isset($ch_subject) and isset($ch_ressource) and isset($ch_decision) and isset($ch_name) and isset($ch_comment) and (!check_input_var('ress','name',$ch_name)))
{
  $tmp=$acls->get_elt($ch_acl);
  if (!isset($tmp))
  {
    add_log($gal_elt_not_exists." acl".$ch_acl);
    log_and_exit(-1);
  }
  $tmp=$groups->get_elt($ch_group);
  if (!isset($tmp) and ($ch_group!=0))
  {
    add_log($gal_elt_not_exists." group".$ch_group);
    log_and_exit(-1);
  }
  $tmp=$protocols->get_elt($ch_protocol);
  if (!isset($tmp) and ($ch_protocol!=0))
  {
    add_log($gal_elt_not_exists." proto".$ch_protocol);
    log_and_exit(-1);
  }
  $tmp=$applications->get_elt($ch_application);
  if (!isset($tmp) and ($ch_application!=0))
  {
    add_log($gal_elt_not_exists." app".$ch_application);
    log_and_exit(-1);
  }
  $tmp=$subjects->get_elt($ch_subject);
  if (!isset($tmp))
  {
    add_log($gal_elt_not_exists." sub".$ch_subject);
    log_and_exit(-1);
  }
  $ret=check_input_var('ress','comment',$ch_comment);
  if ($ret!=0)
  {
      add_log($gal_bad_param_specified."comment)");
      add_log($mess_bad_input_var{$ret});
      log_and_exit(-1);
  }
  $seen_mod=0;
  $my_acl=&$acls->get_elt_by_id($ch_acl);
  $received['ID']=$my_acl->ID;
  $received['from']=$ch_subject;
  if ($ch_subject!=$my_acl->from)
    $seen_mod++;
  $received['to']=$ch_ressource;
  if ($ch_ressource!=$my_acl->to)
    $seen_mod++;
  if ($ch_protocol != 0)
    $received['proto']=$ch_protocol;
  $received['group']=$ch_group;
  if ($ch_group != $my_acl->group)
    $seen_mod++;
  if ($received['proto']!=$my_acl->proto)
    $seen_mod++;
  if ($ch_application != 0)
    $received['with']=$ch_application;
  if ($ch_application!=$my_acl->with)
    $seen_mod++;
  $received['comment']=$ch_comment;
  if ($ch_comment!=$my_acl->comment)
    $seen_mod++;
  $received['decision']=$ch_decision;
  if ($ch_decision!=$my_acl->decision)
    $seen_mod++;
  //$received['name']=$my_acl->name;
  $received['name']=$ch_name;
  if ($ch_name!=$my_acl->name)
    $seen_mod++;
  $received['modified']=$my_acl->modified;
  if ($seen_mod)
    $received['modified']=date("D d M Y");
  $acls->del_elt($my_acl->ID);
  $new_acl=new acl($received,'data',$my_acl->ID);
  $acls->add_elt($new_acl);

//  if (isset($gr_enabled))
  {
    if ($gr_enabled == 'on')
      $gr_enabled=1;
    else if ($gr_enabled == 'off')
      $gr_enabled=0;
    $my_group = &$groups->get_elt_by_id($ch_group);
    if (($gr_enabled == 0) or ($gr_enabled == 1))
      $my_group->enabled = $gr_enabled;
  }


  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}elseif (isset($delete))
{
  //if (preg_match($delete,'/^\d+$/'))
  if (!check_nb($delete))
  {
    add_log($gal_bad_param);
    log_and_exit(-1);
  }
  $tmp=$acls->get_elt($delete);
  if (!isset($tmp))
  {
    add_log($gal_elt_not_exists." delete".$delete);
    log_and_exit(-1);
  }
  //print_r($acls);
  //print_r($delete);
  //print_r($tmp);
  $acls->del_elt($delete);
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}elseif ((isset($macl)) and (isset($up)) and (($up==1) or ($up==-1)))
{
  $list=$acls->ordered_list_tab();
  if (!isset($list))
  {
    $list=array();
  }
  $current=0;$in=0;
  foreach ($list as $is=>$value)
  {
    $last=$current;
    $current=$is;
    if ($current == $macl)
      $in=1;
    if ($in==1)
    {
      if (($last==0) and ($up==1)) #Cannot bring top element up 
        break;
      #bring an element down means bring the following element up
      if ($up==-1)
      {
        $up=1;
        continue;
      }
      $cur_elt=&$acls->get_elt($current);
      $last_elt=&$acls->get_elt($last);
     # add_log("Swapping elements ".$cur_elt->ID." and ".$last_elt->ID);
      $tmpid=$cur_elt->ID;
      $cur_elt->ID=$last_elt->ID;
      $last_elt->ID=$tmpid;
      $acl1=$acls->get_elt($cur_elt->ID);
      $acl2=$acls->get_elt($last_elt->ID);
      $acls->del_elt($cur_elt->ID);
      $acls->del_elt($last_elt->ID);
      $acls->add_elt($acl1,'data',$last_elt->ID);
      $acls->add_elt($acl2,'data',$cur_elt->ID);
      
      $_SESSION['document']=serialize($expolicy);
      $_SESSION['modified']=1;
      break;
    }
  }
}

if (isset($aclorder))
{
  $tab=array();
  $tab2=array();
  $hacls=array();
  foreach($acls->elts as $eid => $elt){
    //print_r($eid);
    //print_r($elt);
    $tid=$elt->ID;
    $tab[$eid]=$elt->ID;
    $tab2[$tid]=$elt->cloneobj();
  }
  $acls2=$acls;
  $done = false;
  foreach (explode('|',$aclorder) as $k => $v) {
    $acltmpx=$tab2[$v];
    $oldid = $acltmpx->ID;
    $acltmp=$acltmpx->cloneobj();
    $acltmp->ID=$k+1; //we don't want 0 as ID
    $hacls[$k+1]=$acltmp;
    if($ch_acl==$oldid && !$done){
      $newid = $acltmp->ID;
      $ch_acl = $newid;
      //print "changing $oldid to $newid\n";
      $done = true;
    }
  }
  $newacls=new obj_set($hacls);
  $acls=$newacls;
  $expolicy->acls=$acls;
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;

}

$ress = &$acls->ordered_list_tab();

$acl=$_REQUEST['acl'];
if (!check_nb($acl))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
//$acl_menu_class= isset($acl)? "aclmenu" : "aclmenu_ext";
$acl_menu_class = "aclmenu_ext";
echo "<div class=\"$acl_menu_class\">\n";
//print "<table>\n";
//echo '<form onsubmit="aclHandle()" action="acls.php" method="post">';
echo '<ul id="sortcat" class="sortul">'."\n";
echo '<form onsubmit="aclHandle()" action="acls.php" method="post">'."\n";
echo '<p><input type="hidden" id="dndSort" name="dndSort" value="" />'.
        '<input type="submit" class="submit" value="'.$gal_save_acl_order.'" />'.
	//'<input class="inspector" type="button" value="Inspect" onclick="junkdrawer.inspectListOrder(\'sortcat\')"/>'.
	'&nbsp<input class="inspector" type="button" value="'.$gal_initial_acl_order.'" onclick="resetOrder(\'sortcat\')"/></p>'.
        '</form>';
if (!isset($ress))
{
  $ress=array();
}
foreach ($ress as $id=>$desc)
{
  //print "  <tr><td><a href=\"acls.php?acl=$id\">$desc</a></td><td><a href=\"acls.php?macl=$id&up=1\"><img src=\"up.gif\" alt=up border=no></a></td><td><a href=\"acls.php?macl=$id&down=1\"><img src=\"down.gif\" alt=\"down\" border=\"no\"></td></tr>\n";
  //print "  <div id=\"dnd$id\"><a href=\"acls.php?acl=$id\">$desc</a></td><td><a href=\"acls.php?macl=$id&up=1\"><img src=\"up.gif\" alt=up border=no></a></td><td><a href=\"acls.php?macl=$id&down=1\"><img src=\"down.gif\" alt=\"down\" border=\"no\"></div>\n";
  $dacl = $acls->get_elt_by_id($id);
  //if(!isset($aclorder))
    //$dacl = $acls->get_elt($id);
  $ddecision = $dacl->decision;
  $class_dec=$dacl->decision;
  $groups=$expolicy->groups;
  $mygrp = $groups->get_elt($dacl->group);
  $enabled=$mygrp->enabled;
  $dname = $dacl->name;
  $idp = sprintf("[%03s]",$id);
  $detail_form='<form action="acls.php" method="post" class="acldetail" onsubmit="aclHandle()">'.
  '<input type="hidden" name="acl" value="'.$id.'" />'.
  '<input type="hidden" name="dndSort" value="" />'.
  '<input type="submit" value="Detail" class="input1 '.$class_dec.'" title="'.$class_dec.'"/>'.
  '</form>';
    if ($enabled == 1)
  {
    $strong='<strong>';
    $strongend='</strong>';
    $span='enabled';
  }
  else
  {
    $strong='';
    $strongend='';
    $span='disabled';
  }

  print "  <li id=\"$id\"><div class=\"sort\" id=\"$id\"><span class=\"$span\">$strong$idp";
  print "<img src=\"images/".$mygrp->ID.".png\" height=15>$strongend $desc</span></div>\n";
  //print"<div class=\"updown\">";
  //print "<a href=\"acls.php?macl=$id&up=1\"><img src=\"up.gif\" alt=up border=no></a><a href=\"acls.php?macl=$id&down=1\"><img src=\"down.gif\" alt=\"down\" border=\"no\"></a>"
  print"$detail_form</li>\n";
}
//print "</table>\n";
echo '</ul>';
echo '<form onsubmit="aclHandle()" action="acls.php" method="post">'."\n";
echo '<p><input type="hidden" id="dndSort" name="dndSort" value="" />'.
        '<input type="submit" class="submit" value="'.$gal_save_acl_order.'" />'.
	'&nbsp<input class="inspector" type="button" value="'.$gal_initial_acl_order.'" onclick="resetOrder(\'sortcat\')"/></p>'.
        '</form>';
print "\n</div>\n";

begin_content_detail();
if (isset($ch_acl)){
  $acl = $ch_acl;
  print "<div class=\"acledit_tab\">";
  $ressources=$expolicy->ressources;
  $subjects=$expolicy->subjects;
  $protocols=$expolicy->protocols;
  $groups=$expolicy->groups;
  $applications=$expolicy->applications;
  $my_acl=$acls->get_elt_by_id($acl);
  if(!isset($aclorder))
    $my_acl = $acls->get_elt($acl);
#  print_r($my_acl);
  print "<h3>[".$my_acl->ID."] ".$my_acl->name."</h3>\n";
  $from=$subjects->get_elt(($my_acl->from));
  $to=$ressources->get_elt($my_acl->to);
  $proto=$protocols->get_elt($my_acl->proto);
  $group=$groups->get_elt($my_acl->group);
  $with=$applications->get_elt($my_acl->with);
  print "<form method=\"post\" action=\"acls.php\" onsubmit=\"aclHandle()\" name=\"acls\"><input type=\"text\" style=\"width:100%\" name=\"ch_name\" value=\"".$my_acl->name."\">";
  #print "<form method=\"post\" action=\"acls.php\" onsubmit=\"aclHandle()\" name=\"acls\"><input type=\"text\" style=\"width:100%\" name=\"ch_name\" value=\"".$my_acl->name."\"><input type=hidden name=acl_nb value=".$my_acl->ID.">";
  echo '<input type="hidden" name="dndSort" value="" />';
  print "<div class=\"".$my_acl->decision."\">[".$proto->name."][".$with->name."]".$from->name." =>".$to->name."</div>\n";
  print "<input type=hidden name=acl value=\"$acl\">\n";


  print "<table class=\"acl_edit\"><tr><td class=\"rowtitle\">$string_protocol</td><td> <select name=protocol>\n";
  print "<option value=\"0\">--</option>";

  $array_protos=array();
  foreach (($protocols->list_tab()) as $key=>$pro)
  {
    array_push($array_protos,$pro);
  }
  sort($array_protos);

  foreach ($array_protos as $pro)
  {
    foreach ($protocols->list_tab() as $key=>$foo)
    {
      if ($foo==$pro)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($pro == $proto->name)
        echo " selected";
      print ">".$pro."</option>";
    }
  }
  print " </select></td></tr>\n";

  print "<tr><td class=\"rowtitle\">$string_application</td><td> <select name=application>\n";
  print "<option value=\"0\">--</option>";

  $array_applications=array();
  foreach (($applications->list_tab()) as $key=>$app)
  {
    array_push($array_applications,$app);
  }
  sort($array_applications);

  foreach ($array_applications as $app)
  {
    foreach ($applications->list_tab() as $key=>$foo)
    {
      if ($foo==$app)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($app == $with->name)
        echo " selected";
      print ">".$app."</option>";
    }
  }
  print " </select></td></tr>\n";



  print "<tr><td class=\"rowtitle\">$string_subject</td><td> <select name=subject>\n";
  $array_subjs=array();
  foreach (($subjects->list_tab()) as $key=>$sub)
  {
    array_push($array_subjs,$sub);
  }
  sort($array_subjs);
  foreach ($array_subjs as $sub)
  {
    foreach ($subjects->list_tab() as $key=>$foo)
    {
      if ($foo==$sub)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($sub == $from->name)
        echo " selected";
      print ">".$sub."</option>";
    }
  }
  print " </select></td></tr>\n";
  print "<tr><td class=\"rowtitle\">$string_ressource</td><td> <select name=ressource>\n";


  $array_ress=array();
  foreach (($ressources->list_tab()) as $key=>$res)
  {
    array_push($array_ress,$res);
  }
  sort($array_ress);
  foreach ($array_ress as $res)
  {
    foreach ($ressources->list_tab() as $key=>$foo)
    {
      if ($foo==$res)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($res == $to->name)
        echo " selected";
      print ">".$res."</option>";
    }
  }
  print "</select></td></tr>\n";
  print "<tr><td class=\"rowtitle\">$string_decision</td><td> <select name=decision>\n";
  foreach (possible_values('acl','decision') as $possible)
  {
    print " <option";
    if ($possible==$my_acl->decision) echo " selected";
    print ">$possible</option>";
  }
  print "</select> </td></tr>";
  print "<tr><td class=\"rowtitle\">modified</td><td>".$my_acl->modified."</td><td></td></tr>";


  print "<tr><td class=\"rowtitle\">$string_group</td><td> <select name=group";
      print " onChange=\"change_group_value();\">\n";
#  print "<option value=\"0\">--</option>";

  $array_groups=array();
  foreach (($groups->list_tab()) as $key=>$app)
  {
    array_push($array_groups,$app);
  }
  sort($array_groups);

  $selected=0;
  foreach ($array_groups as $grp)
  {
    foreach ($groups->list_tab() as $key=>$foo)
    {
      if ($foo==$grp)
        break;
    }
    if ($key!=""){
      print "<option value=\"$key\"";
      if ($grp == $group->name)
      {
        echo " selected";
        $selected=$group->enabled;
      }
      #print "onFocus=\"griser_gren();\" onChange=\"griser_gren();\"";
      print ">".$grp."</option>";
    }
  }
  ?>
  </select></td><td> 
  <?php
  print $mess_enabled;
  ?>
  
  <input type="checkbox" name="gr_enabled"
  <?php
  if ($selected == 1)
    print " checked";
  print ">";
  
  ?>
  </td></tr>

  
  <?php





  print "</table>";
  print "<table><tr><td>Comment</td><td>";
  print "<textarea name=comment cols=29>";
  print $my_acl->comment;
  print "</textarea>";
  print "</td></tr></table>\n";
  print "<input type=\"submit\"  value=\"$gal_button_apply\" class=\"button\" />";
  echo '<input type="hidden" name="dndSort" value="" />';
  print "</form>\n";
  print "<form action=\"acls.php\" method=\"post\" onsubmit=\"return ask_user_acl()\">";
  print "<input type=hidden name=delete value=$acl><input type=submit value=\"$mess_index_button_delete\" class=\"button\" /></form>";
  print "</div>";
}else{
  ?>
Groups
<form action="acls.php" method=post>
<input type=hidden name=modify_groups value=1>
<table>
<?php
print "<tr><td><b>ID</b></td><td><b>$mess_symbol</b></td><td><b>$mess_label</b></td><td><b>$mess_comment</b></td><td><b>$mess_enabled</b></td><td><strong>$mess_index_button_delete</strong></td></tr>\n";
  $groups=$expolicy->groups;
  $array_groups=array();
  foreach ($groups->list_tab() as $key=>$foo)
  {
    if($foo){
        array_push($array_groups,$key);
    }
  }
  sort($array_groups);

  foreach ($array_groups as $key)
  {
    $group=$groups->get_elt($key);
  #    $group = &$groups->get_elt_by_id($key);
      print "<tr><td>".$key."</td><td><img src=\"images/".$key.".png\"></td><td><input type=text name=name".$key." value=\"".$group->name."\"></td><td><input type=text name=comment".$key." value=\"".$group->comment."\"></td><td><input type=checkbox name=enabled".$key." ";
      if ($group->enabled == 1)
        echo "checked";
      $v = '0';
      if($group->is_used == false){
          $v='1';
          $v_form_del = '<input type="checkbox" name="del_grp['.$group->ID.']"/>';
      }
      echo "></td><td>$v_form_del</td></tr>\n";

    }
?>  
</table>
<input type="submit">
</form>
  <?php
}
end_content_detail();
?>

<?php
require("include/footer.php");
?>
