<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

require_once("security.php");

if (version_compare(PHP_VERSION,'5','>=') && !extension_loaded("domxml"))
       require_once('domxml-php4-to-php5.php');

#Do not change this unless you know what you are doing!
$xml_nuface_version="1.0";

class elt {
    var $datas;
    function display($scope='one',$base=null) {
        if (($this->datas['type'] == 'link') and ($base and ($scope=='all'))){
            $base->display_elt($this->datas['linkid'],$scope,$base);
        } else {
            foreach($this->datas as $key=>$data){
                echo "$key : ".$data." ";
            }
        }
        echo "<br>";
    }
    function xmldump($xml,$curelt){
        $node=$xml->create_element( 'elt' );
        foreach($this->datas as $key=>$data){
          if (($data != '--') and ($data != ''))
                $node->set_attribute($key,$data);
        }
        $curelt->append_child($node);
    }
    function express($base=null) {
        $result=array();
        if (($this->datas['type'] == 'link')){
            $base->express_elt($this->datas['linkid'],'all',$base);
        } else {
            foreach($this->datas as $key=>$data){
                $result[$key]=$data;
            }
        }
        return($result);
    }
    function elt($data,$type='xml',$id=0){
      if ($type == 'xml')
      {
        $struct=$data->attributes();
        foreach($struct as $attr){
            $this->datas[$attr->name()]=$attr->value();
        }
      }else{
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $data["ID"]=$id;
        $this->datas=$data;
      }
    }
    function get_id(){
      return $this->datas["ID"];
    }
#    function list_tab()
#    {
#        foreach ($this->elts as $elt){
#          if ($elt->name!=''){
#            $result{$elt->ID} = ($elt->name);
#          }else{
#            $result{$elt->ID} = $elt->ID;
#          }
#        }
#      return $result;
#    }
    function get_obj()
    {
      $result=array();
      foreach ($this->datas as $key=>$obj)
      {
        $result{$key}=$obj;
      }
      return $result;
    }
}

#class ipv4_elt extends elt {
#    var $net;
#    var $dport;
#}

class set {
    var $elts;
}

class obj_set extends set {
    function display($scope='one'){
        foreach ($this->elts as $key=>$elt){
            printf("%d : ",$key);
            $elt->display($scope,$this);
            echo "<br>";
        }
    }
    function xmldump($xml,$curelt){
        # TODO : use a DTD to do that ?
         $tagname = preg_replace('/s$/','', $curelt->tagname);
         if (isset($this->elts))
         foreach ($this->elts as $key=>$elt){
               if(!isset($elt)){
                   continue;
               }
               $node = $xml->create_element($tagname);
#               $node->set_attribute('linkid',$key);
               $elt->xmldump($xml,$node);
               $curelt->append_child($node);
         }
    }
    function display_elt($elt,$scope="one"){
        $this->elts[$elt]->display($scope,$base=$this);
    }
    function express_elt($elt,$scope="one"){
        $this->elts[$elt]->express($scope,$base=$this);
    }
    function obj_set($hash){
        $this->elts=$hash;
    }
    function &get_elt($elt){
        return $this->elts[$elt];
    }
    function &get_elt_by_id($id){
	foreach ($this->elts as $index => $elt){
		if ($elt->ID == $id){
			return $this->elts[$index];
		}
	}
	return null;
    }
    function replace_elt($index,$elt){
        unset ($this->elts[$index]);
        $this->elts[$index]=$elt;
    }
    function del_elt($index){
        unset ($this->elts[$index]);
    }
    function add_elt($elt){
        $this->elts[$elt->get_id()]=$elt;
    }
    function get_max_elt_id(){
      $max=0;
      if (!isset($this->elts))
        return(0);
      foreach (($this->elts) as $elts){
        $local = $elts->get_max_elt_id();
        if ($local>$max)
          $max = $local;
      }
      return $max;
    }
    function new_elt_id(){
      return $this->get_max_elt_id() + 1;
    }
    function get_max_id(){
      $max=0;
      if (isset($this->elts))
        foreach (($this->elts) as $elts){
          $local=$elts->get_id();
          if ($local>$max)
            $max=$local;
        }
      return $max;
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function list_tab()
    {
      $result=array();
      if (isset($this->elts))
        foreach ($this->elts as $elt){
          if ($elt->name!=''){
            $result{$elt->ID} = ($elt->name);
          }else{
            $result{$elt->ID} = $elt->ID;
          }
        }
      return $result;
    }
    function ordered_list_tab()
    {
      $ids=array();
      if (isset($this->elts))
      	foreach ($this->elts as $elt){
        	array_push($ids,$elt->ID);
      	}
      sort($ids);

      foreach ($ids as $id){
        foreach ($this->elts as $elt){
          if ($id == $elt->ID){
            if ($elt->name!=''){
              $result{$elt->ID} = ($elt->name);
            }else{
              $result{$elt->ID} = $elt->ID;
            }
          }
        }
      }
      return $result;
    }
    function nb_obj(){
      $result=0;
      foreach ($this->elts as $elt){
        $result++;
      }
      return($result);
    }

    function reorder(){
        $i=1;
        $clone = new obj_set(array());
        foreach($this->elts as $id_t =>$elt){
           $elt->ID = $i;
           $clone->add_elt($elt);
           $i++;
        }
        return $clone;
    }
}

class elt_set extends set {
    var $name;
    var $operator;
    var $ID;
    function display($scope='one',$base=null) {
        echo $this->name."<br>";
        echo "Logical op: ".$this->operator."<br>";
        foreach ($this->elts as $key=>$elt){
            echo "$key : ";
            $elt->display($scope,$base);
        }
    }
    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        $node->set_attribute('op',$this->operator);
        $node->set_attribute('ID',$this->ID);
        foreach ($this->elts as $elt){
                $elt->xmldump($xml,$node);
        }
    }
    function elt_set($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->operator=$ress['operator'];
        $this->name=$ress['name'];
      }else{
        $this->operator=$ress->get_attribute('op');
        $this->name=$ress->get_attribute('name');
        $this->ID=$ress->get_attribute('ID');
      }
    }
    function add_elt($elt){
        $this->elts[$elt->get_id()]=$elt;
    }
    function del_elt($index){
        #array_splice($this->elts,$index,1);
        unset ($this->elts[$index]);
    }
    function modify_param($param,$value){
        if ($param == 'ID'){
          return(-1);
        }
        if (($param=='name') or ($param=='operator') or ($param=='comment') or ($param=='modified')){
          $this->$param=$value;
          return(0);
        }
        return(-1);
    }
    
    function &get_elt($elt){
        return $this->elts[$elt];
    }
    function get_id(){
      return($this->ID);
    }
    function get_max_elt_id(){
        $max=0;
        foreach ($this->elts as $elt){
            $local=$elt->get_id();
            if ($local>$max)
              $max=$local;
        }
        return $max;
    }
    function list_tab()
    {
        foreach ($this->elts as $elt){
          if ($elt->datas['name']!=''){
            $result{$elt->datas['ID']} = ($elt->datas['name']);
          }else{
            $result{$elt->datas['ID']} = $elt->datas['ID'];
          }
        }
      return $result;
    }
    function get_obj()
    {
      foreach ($this as $key=>$obj)
      {
#Skip elts, that contains stuff from subelements
        if ($key=='elts')
          continue;
        $result{$key}=$obj;
      }
      return $result;
    }
}

class ressource extends elt_set {
    function ressource($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml'){
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
    function express($ress){
        foreach($ress->get_elements_by_tagname("elt") as $resselt){
          $result=$resselt->express;
        }
    }
}

class subject extends elt_set {
    function subject($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}

class application extends elt_set {
    function application($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}


class protocol extends elt_set {
    function protocol($ress,$type='xml',$id=0){
        $this->elts=array();
        parent::elt_set($ress,$type,$id);
        if ($type=='xml')
        {
          foreach($ress->get_elements_by_tagname("elt") as $resselt){
            $selt=new elt($resselt);
            $id=$resselt->get_attribute('ID');
            $this->elts[$id] = $selt;
#            array_push($this->elts,$selt);
          }
        }
# TODO add some checking
    }
}

class acl {
  var $name;
  var $from;
  var $with;
  var $to;
  var $proto;
  var $ID;
  var $decision;
  var $modified;
  var $comment;
  var $group;
    function acl($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->name=$ress['name'];
        $this->from=$ress['from'];
        if (($ress['with']!=0) and ($ress['with']!=''))
          $this->with=$ress['with'];
        if (($ress['proto']!=0) and ($ress['proto']!=''))
          $this->proto=$ress['proto'];
        $this->to=$ress['to'];
        $this->decision=$ress['decision'];
        $this->comment=$ress['comment'];
        $this->modified=$ress['modified'];
        $this->group=$ress['group'];
        if ((!isset($this->group)) or ($this->group == ''))
          $this->group=1;
#        defined ($this->group) or $this->group=1;
      }else{
        $this->name=$ress->get_attribute('name');
        $this->from=$ress->get_attribute('from');
        $this->to=$ress->get_attribute('to');
        if (($ress->get_attribute('with')) and ($ress->get_attribute('with')!=''))
          $this->with=$ress->get_attribute('with');
        if (($ress->get_attribute('proto')) and ($ress->get_attribute('proto')!=''))
          $this->proto=$ress->get_attribute('proto');
        $this->ID=$ress->get_attribute('ID');
        $this->decision=$ress->get_attribute('decision');
        $this->modified=$ress->get_attribute('modified');
        $this->comment=$ress->get_attribute('comment');
        $this->group=$ress->get_attribute('group');
        if ((!isset($this->group)) or ($this->group == ''))
          $this->group=1;
#        defined ($this->group) or $this->group=1;
      }
    }

    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        $node->set_attribute('from',$this->from);
        $node->set_attribute('to',$this->to);
        if ($this->with!='')
          $node->set_attribute('with',$this->with);
        if ($this->proto!='')
          $node->set_attribute('proto',$this->proto);
        $node->set_attribute('ID',$this->ID);
        $node->set_attribute('decision',$this->decision);
        $node->set_attribute('comment',$this->comment);
        $node->set_attribute('modified',$this->modified);
        $node->set_attribute('group',$this->group);
    }

    function display($scope='one',$base=null) {
        echo "$this->name : from $this->from with $this->with to $this->to protocol $this->proto decision $this->decision<br>"; 
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function get_id(){
      return($this->ID);
    }
    function cloneobj(){
      $t=array();
      $t['name']=$this->name;
      $t['proto']=$this->proto;
      $t['from']=$this->from;
      $t['with']=$this->with;
      $t['to']=$this->to;
      $t['ID']=$this->ID;
      $t['decision']=$this->decision;
      $t['modified']=$this->modified;
      $t['comment']=$this->comment;
      $t['group']=$this->group;
#      defined ($t['group']) or $t['group'] = 1;
      return new acl($t,$type='toto',$id=$t['ID']);
    }
}

class nat {
  var $name;
  var $srcnet;
  var $dstnet;
  var $proto;
  var $ID;
  var $sport;
  var $dport;
  var $icmptype;
  var $rewritetoaddr;
  var $rewritetoport;
  var $group;
    function nat($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->name=$ress['name'];
        if (($ress['srcnet']!=0) and ($ress['srcnet']!=''))
          $this->srcnet=$ress['srcnet'];
        if (!preg_match('/^$/',$ress['dstnet']))
          $this->dstnet=$ress['dstnet'];
        $this->proto=$ress['proto'];
        if (($ress['sport']!=0) and ($ress['sport']!=''))
          $this->sport=$ress['sport'];
        if (($ress['dport']!=0) and ($ress['dport']!=''))
          $this->dport=$ress['dport'];
        $this->icmptype=$ress['icmptype'];
        if (($ress['rewritetoaddr']!=0) and ($ress['rewritetoaddr']!=''))
          $this->rewritetoaddr=$ress['rewritetoaddr'];
        if (($ress['rewritetoport']!=0) and ($ress['rewritetoport']!=''))
          $this->rewritetoport=$ress['rewritetoport'];
        $this->comment=$ress['comment'];
        $this->modified=$ress['modified'];
        $this->group=$ress['group'];
#        defined ($this->group) or $this->group=1;
      }else{
        $this->name=$ress->get_attribute('name');
        if (($ress->get_attribute('srcnet')) and ($ress->get_attribute('srcnet')!=''))
          $this->srcnet=$ress->get_attribute('srcnet');
        if (($ress->get_attribute('dstnet')) and ($ress->get_attribute('dstnet')!=''))
          $this->dstnet=$ress->get_attribute('dstnet');
        if (($ress->get_attribute('proto')) and ($ress->get_attribute('proto')!=''))
          $this->proto=$ress->get_attribute('proto');
        if (($ress->get_attribute('sport')) and ($ress->get_attribute('sport')!=''))
          $this->sport=$ress->get_attribute('sport');
        if (($ress->get_attribute('dport')) and ($ress->get_attribute('dport')!=''))
          $this->dport=$ress->get_attribute('dport');
        if (($ress->get_attribute('icmptype')) and ($ress->get_attribute('icmptype')!=''))
          $this->icmptype=$ress->get_attribute('icmptype');
        $this->ID=$ress->get_attribute('ID');
        if (($ress->get_attribute('rewritetoaddr')) and ($ress->get_attribute('rewritetoaddr')!=''))
          $this->rewritetoaddr=$ress->get_attribute('rewritetoaddr');
        if (($ress->get_attribute('rewritetoport')) and ($ress->get_attribute('rewritetoport')!=''))
          $this->rewritetoport=$ress->get_attribute('rewritetoport');
        $this->modified=$ress->get_attribute('modified');
        $this->comment=$ress->get_attribute('comment');
        $this->group=$ress->get_attribute('group');
#        defined ($this->group) or $this->group=1;
      }
    }

    function del_elt($index){
        unset ($this);
    }

    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        if ($this->srcnet!='')
          $node->set_attribute('srcnet',$this->srcnet);
        if ($this->dstnet!='')
          $node->set_attribute('dstnet',$this->dstnet);
        if ($this->proto!='')
          $node->set_attribute('proto',$this->proto);
        if ($this->sport!='')
          $node->set_attribute('sport',$this->sport);
        if ($this->dport!='')
          $node->set_attribute('dport',$this->dport);
        if ($this->icmptype!='')
          $node->set_attribute('icmptype',$this->icmptype);
        if ($this->rewritetoaddr!='')
          $node->set_attribute('rewritetoaddr',$this->rewritetoaddr);
        if ($this->rewritetoport!='')
          $node->set_attribute('rewritetoport',$this->rewritetoport);
        $node->set_attribute('ID',$this->ID);
        $node->set_attribute('comment',$this->comment);
        $node->set_attribute('modified',$this->modified);
        $node->set_attribute('group',$this->group);
    }

    function display($scope='one',$base=null) {
        echo "$this->name : from $this->srcnet to $this->dstnet protocol $this->proto to $this->rewritetoaddr<br>"; 
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function get_id(){
      return($this->ID);
    }
    function cloneobj(){
      $t=array();
      $t['name']=$this->name;
      $t['proto']=$this->proto;
      $t['srcnet']=$this->srcnet;
      $t['dstnet']=$this->dstnet;
      $t['sport']=$this->sport;
      $t['dport']=$this->dport;
      $t['icmptype']=$this->icmptype;
      $t['ID']=$this->ID;
      $t['rewritetoaddr']=$this->rewritetoaddr;
      $t['rewritetoport']=$this->rewritetoport;
      $t['group']=$this->group;
#      defined ($t['group']) or $t['group'] = 1;
      return new nat($t,$type='toto',$id=$t['ID']);
    }
}

class group {
  var $name;
  var $ID;
  var $enabled;
  var $comment;
    function group($ress,$type='xml',$id=0){
      if ($type != 'xml')
      {
        if ($id==0){
          echo "Must be passed a valid ID!";
          return(-1);
        }
        $this->ID=$id;
        $this->name=$ress['name'];
        $this->enabled=$ress['enabled'];
        $this->comment=$ress['comment'];
        $this->is_used = false;
        if ($ress['is_used'] != ''){
            $this->is_used = true;
        }
#        defined ($this->enabled) or $this->enabled = 1;
      }else{
        $this->name=$ress->get_attribute('name');
        $this->ID=$ress->get_attribute('ID');
        $this->enabled=$ress->get_attribute('enabled');
        $this->comment=$ress->get_attribute('comment');
        $this->is_used = false;
#        defined ($this->enabled) or $this->enabled = 1;
      }
    }
    function del_elt($index){
        unset ($this);
    }

    function xmldump($xml,$node){
        $node->set_attribute('name',$this->name);
        $node->set_attribute('ID',$this->ID);
        $node->set_attribute('comment',$this->comment);
        $node->set_attribute('enabled',$this->enabled);
    }
    function new_id(){
      return($this->get_max_id()+1);
    }
    function get_id(){
      return($this->ID);
    }
    function cloneobj(){
      $t=array();
      $t['name']=$this->name;
      $t['ID']=$this->ID;
      $t['group']=$this->group;
      $t['enabled']=$this->enabled;
      $t['comment']=$this->comment;
      $t['is_used']=$this->is_used;
#      defined($t['enabled']) or $t['enabled']=1;
      return new group($t,$type='toto',$id=$t['ID']);
    }
}


class policy extends elt {
    /* 3 hashs containing needed informations */
    var $ressources;
    var $subjects;
    var $applications;
    var $protocols;
    var $acls;
    var $snats;
    var $dnats;
    var $pnats;
    var $groups;

    /* creator from xml file */
    function policy($file){
        if (!$dom = domxml_open_file($file)) {
            //echo "Error while parsing the document\n";
            //exit;
            unset($this);
            return;
        }
        $root = $dom->document_element();
        $ressources = $root->get_elements_by_tagname("ressources");
        $ressources=$ressources[0];
        /* iter on ressource */
        $ressource_list=$ressources->get_elements_by_tagname("ressource");
        foreach ($ressource_list as $ress){
            $newress=new ressource($ress);
            $id=$ress->get_attribute("ID");
            $hash_ress[$id]=$newress;
        }
        $this->ressources=new obj_set($hash_ress);

        $subjects = $root->get_elements_by_tagname("subjects");
        $subjects=$subjects[0];
        $subject_list=$subjects->get_elements_by_tagname("subject");
        foreach ($subject_list as $sub){
            $newsub=new subject($sub);
            $id=$sub->get_attribute("ID");
            $hash_sub[$id]=$newsub;
        }
        $this->subjects=new obj_set($hash_sub);

        $applications = $root->get_elements_by_tagname("applications");
        $applications=$applications[0];
        $application_list=$applications->get_elements_by_tagname("application");
        foreach ($application_list as $app){
            $newapp=new application($app);
            $id=$app->get_attribute("ID");
            $hash_app[$id]=$newapp;
        }
        $this->applications=new obj_set($hash_app);

        $protocols = $root->get_elements_by_tagname("protocols");
        $protocols=$protocols[0];
        $protocol_list=$protocols->get_elements_by_tagname("protocol");
        foreach ($protocol_list as $pro){
            $newprot=new protocol($pro);
            $id=$pro->get_attribute("ID");
            $hash_proto[$id]=$newprot;
        }
        $this->protocols=new obj_set($hash_proto);

        $acls = $root->get_elements_by_tagname("acls");
        $acls=$acls[0];
        $acl_list=$acls->get_elements_by_tagname("acl");
        foreach ($acl_list as $sub){
            $newsub=new acl($sub);
            $id=$sub->get_attribute("ID");
            $hash_acls[$id]=$newsub;
        }
        $this->acls=new obj_set($hash_acls);

        $snats = $root->get_elements_by_tagname("snats");
        $snats=$snats[0];
        $snat_list=$snats->get_elements_by_tagname("snat");
        foreach ($snat_list as $sub){
            $newsub=new nat($sub);
            $id=$sub->get_attribute("ID");
            $hash_snats[$id]=$newsub;
        }
        $this->snats=new obj_set($hash_snats);

        $dnats = $root->get_elements_by_tagname("dnats");
        $dnats=$dnats[0];
        $dnat_list=$dnats->get_elements_by_tagname("dnat");
        foreach ($dnat_list as $sub){
            $newsub=new nat($sub);
            $id=$sub->get_attribute("ID");
            $hash_dnats[$id]=$newsub;
        }
        $this->dnats=new obj_set($hash_dnats);

        $pnats = $root->get_elements_by_tagname("pnats");
        $pnats=$pnats[0];
        $pnat_list=$pnats->get_elements_by_tagname("pnat");
        foreach ($pnat_list as $sub){
            $newsub=new nat($sub);
            $id=$sub->get_attribute("ID");
            $hash_pnats[$id]=$newsub;
        }
        $this->pnats=new obj_set($hash_pnats);

        $groups = $root->get_elements_by_tagname("groups");
        $groups=$groups[0];
        $group_list=$groups->get_elements_by_tagname("group");
        foreach ($group_list as $sub){
            $newsub=new group($sub);
            $id=$sub->get_attribute("ID");
            $hash_groups[$id]=$newsub;
        }
        $this->groups=new obj_set($hash_groups);
    }
    function xmldump($filename=''){
        global $xml_nuface_version;
        # create new xml document
        $xml = domxml_new_doc( '1.0' );
        $root = $xml->create_element('policy');
        $root->set_attribute('version',"$xml_nuface_version");
        $new_root = $xml->append_child($root);
        #ressources
        $node = $xml->create_element( 'ressources' );
        $newnode = $new_root->append_child($node);
        $this->ressources->xmldump($xml,$newnode);
        #subjects
        $node = $xml->create_element( 'subjects' );
        $newnode = $new_root->append_child($node);
        $this->subjects->xmldump($xml,$newnode);
        #applications
        $node = $xml->create_element( 'applications' );
        $newnode = $new_root->append_child($node);
        $this->applications->xmldump($xml,$newnode);
        #protocols
        $node = $xml->create_element( 'protocols' );
        $newnode = $new_root->append_child($node);
        $this->protocols->xmldump($xml,$newnode);
        #acls
        $node = $xml->create_element( 'acls' );
        $newnode = $new_root->append_child($node);
        $this->acls->xmldump($xml,$newnode);
        #snats
        $node = $xml->create_element( 'snats' );
        $newnode = $new_root->append_child($node);
        $this->snats->xmldump($xml,$newnode);
        #dnats
        $node = $xml->create_element( 'dnats' );
        $newnode = $new_root->append_child($node);
        $this->dnats->xmldump($xml,$newnode);
        #pnats
        $node = $xml->create_element( 'pnats' );
        $newnode = $new_root->append_child($node);
        $this->pnats->xmldump($xml,$newnode);
        #groups
        $node = $xml->create_element( 'groups' );
        $newnode = $new_root->append_child($node);
        $this->groups->xmldump($xml,$newnode);
        # dump xml document
        if ($filename=='')
        {
          echo $xml->dump_mem( true, 'UTF-8' ) ;
          return(1);
        }else{
          return($xml->dump_file($filename,false,true));
        }
    }
}


function read_file($filename){
  if (!check_filename($filename))
    return(-1);
  global $datadir;
  $expolicy= new policy($datadir.'/'.$filename);
  return $expolicy;
}

function save_file($expolicy,$filename=''){
  global $datadir;
  if (!check_filename($filename))
    return(-1);
  if ($filename==''){
    return($expolicy->xmldump());
  }
  else
  {
    return($expolicy->xmldump($datadir.'/'.$filename));
  }
}

function del_file($filename=''){
  global $datadir;
  if (!check_filename($filename))
    return(-1);
  if ($filename==''){
    return(0);
  }
  return(unlink($datadir.'/'.$filename));
}

function cmp_file($elt1, $elt2){
 if ($elt1["mtime"] == $elt2["mtime"])
 {
   return 0;
 }
 return ($elt2["mtime"] > $elt1["mtime"]) ? 1: -1;
}

function file_list(){
 global $datadir;
 $files = array();  
 $res = array();
 $dir = opendir($datadir);  
 if (! $dir)
 {
echo "<div class=content><div class=console>Could not open directory \$datadir!\n<div class=warning> Please check your configuration</div></div></div>";
    return(-1);
 }
 while(($file = readdir($dir)) !== false)  
 {  
  if($file !== '.' && $file !== '..' && !is_dir($file))  
  {  
    clearstatcache();
    $mtime = stat($datadir."/".$file);
    $mtime = $mtime["mtime"];
    $files[] = array("file" => $file, "mtime" => $mtime);  
  }  
 }  
 closedir($dir);  
 usort($files,"cmp_file");
 foreach($files as $elt)
 {
   $res[] = $elt["file"];
 }
 return($res);
}

function max_elt($array)
{
  $max=0;
  if (isset($array) and ($array!=''))
    foreach ($array as $elt)
    {
      $local=$elt->get_ID();
      if ($local>$max)
        $max=$local;
    }
  return($max);
}

function print_console($msg)
{
  print "<div class=\"console\">$msg</div>";
}

function print_consolebis($msg)
{
  print "<div class=\"console2\">$msg</div>";
}
$log_console='';
function add_log($s)
{
  global $log_console;
  $log_console .= $s."<br />";
}

function print_console2()
{
  global $log_console;
  if($log_console!=""){
    print_console($log_console);
  }
}

function begin_content_detail(){
  echo '<div class="content">';
  print_console2();
}

function end_content_detail(){
  //print_console2();
  echo '</div> <!-- content -->';
}

function begin_acls_use(){
  echo '<div class="acl_use">';
}

function show_acls_use($acls,$type,$id,$mess){
  $used=0;
  if (isset($acls->elts))
    foreach($acls->elts as $acl)
    {
    	print "<table>";
      if (isset($acl->$type) and ($acl->$type == $id))
      {
#        print "<div class=\"".$acl->decision."\"><a href=\"acls.php?acl=".$acl->ID."\">".$acl->name."</a></div>\n";
        print "<tr><td class=\"".$acl->decision."\">".$acl->name."</td><td><form action=\"acls.php\"><input type=hidden name=acl value=\"".$acl->ID."\"><input type=image src=\"go\"></form></td></tr>\n";
        $used++;
      }
      print "</table>";
    }
  if ($used == 0)
  {
    print "<i>$mess</i>";
  }
}

function end_acls_use(){
  echo "</div> <!-- acl_use -->\n";
}


function end_page(){
  include('footer.php');
}

function log_and_exit($exit_code){
  begin_content_detail();
  end_content_detail();
  end_page();
  exit($exit_code);
}

function gen_nupyf_args($dir,$dispatch,$forward,$input,$output,$nat,$rescue){
  $args = '';
  if ($rescue == true)
    $args .= $args . ' --rescue';
  if ($dispatch != '')
    $args .= " --dispatch $dir/$dispatch";
  if ($forward != '')
    $args .= " --forward $dir/$forward";
  if ($input != '')
    $args .= " --input $dir/$input";
  if ($output != '')
    $args .= " --output $dir/$output";
  if ($nat != '')
    $args .= " --nat $dir/$nat";
  return $args;
}

function report_execute($command,&$result){
  $handle = popen($command,'r');
  $ret = '';
  while(!feof($handle)){
    $ret .= fread($handle,2048);
  }
  $result = pclose($handle);
  return $ret;
}

function rename_if_exists($src,$dst){
  if (file_exists($src)){
    rename($src,$dst);
  }
}

function show_floatings($floating,$gal_working_elts,$gal_type,$gal_name,$gal_operation,$gal_button_add,$in_elt,$elt,$page)
{
	if (isset($floating) and ($floating!=''))
	{
	  print "<div class=\"floating\">";
          print "<a href=\"#\" onclick=\"javascript:toggle_all_tab('tab1')\" onload=\"javascript:toggle_all_tab('tab1')\">$gal_working_elts</a>";
	  print "<table id=\"tab1\"><tr><td>$gal_name</td><td>$gal_type</td><td>$gal_operation</td></tr>";
#          print "<div class=\"menu\" id=\"tab1\">";
	  foreach($floating as $f_elt)
	  {
	    $data=$f_elt->get_obj();
	    if (isset($data['name'])){
	      print "<tr><td>".$data['name']."</td><td>".$data['type']."</td><td>";
	      if ($in_elt == 1)
	        print "<form action=\"$page.php\" method=POST><input type=hidden
	        name=add_float value=".$data['ID']."><input type=hidden name=elt
	        value=$elt><input type=submit value=\"$gal_button_add\" class=\"button\"></form>";
	      else
	        print "N/A";
	      print "</td></tr>";
	    }
	    else{
	      print "<tr><td>".$data['ID']."</td><td>".$data['type']."</td><td>";
	      if ($in_elt == 1)
	        print "<form action=\"$page.php\" method=POST><input type=hidden
	        name=add_float value=".$data['ID']."><input type=hidden name=elt
	        value=$elt><input type=submit value=\"$gal_button_add\" class=\"button\"></form>";
	      else
	        print "N/A";
	      print "</td></tr>";
	    }
	  }
#          print "</div>";
	}
}

function init_floatings(&$floating)
{
  if (!isset($floating) or ($floating==''))
  {
    $floating=array();
    foreach (array('ipv4','nufw','link','proto','app') as $mytype)
    {
      $received['type']=$mytype;
      $received['name']='_'.$mytype;
      $new_elt=new elt($received,'data',max_elt($floating)+1);
      array_push($floating,$new_elt);
    }
  $_SESSION['floating_elts']=serialize($floating);
  }
}


function print_js_groups_tab($groups){
    $array_groups = array();
    foreach ($groups->list_tab() as $key=>$foo){
       array_push($array_groups,$key); 
    }
    echo '<script>';
    echo 'glob_groups_t = Array();';
    foreach ($array_groups as $key){
        $group=$groups->get_elt($key);
        $enabled = $group->enabled == 1? '1':'0';
        echo "glob_groups_t['$key']=$enabled;";
    }
    echo '</script>';
}


/*
 * This function read opened file represented by handler
 * and returns array of strings, each a line from the file
 */
function freadlines($handle){
    $output= array();
    if ($handle){
        while (!feof($handle)){
            $l= trim(fgets($handle));
            $output[] = $l;
        }
    }
    return $output;
}

/*
 *   get groups: name and gid
 * $file: path to file to read instead of running getent
 * $sysgroupfile: path to local groups file. groups belonging to this file will not be included
 * in final result
 * return: array gid=>name
*/
function getent_user_groups($file='', $sysgroupfile=''){
    $output = array();
    $sysgroups = array();
    $ret = 0;
    $result = array();
    /*if file is set, get group from it instead of getent */
    if($file != ''){
        $handle = fopen($file,'r');
        if($handle){
            $output = freadlines($handle);
            fclose($handle);
        }
    }else{
        exec("getent group",$output,$ret);
    }
    if($sysgroupfile != ''){//get groups from /etc/group
        $handleg = fopen($sysgroupfile,'r');
        $linesg = freadlines($handleg);
        foreach($linesg as $line){
            $t = explode(':',$line);
            $sysgroups[] = $t[0];
        }
    }
    foreach($output as $line){
        /* $line is group_name:x:gid: */
        $t = explode(':',$line);
        if (!in_array($t[0], $sysgroups)){//add groups to result only if not in sysgroups
            $result[$t[2]] = $t[0];
        }
    }
    return $result;
}
