<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

function check_ip($ip)
{
  if (!preg_match('/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/',$ip,$matches))
    return(0);
  if (($matches[1]<1) or ($matches[1]>255))
    return(0);
  for ($i=2;$i<5;$i++)
    if (($matches[$i]<0) or ($matches[$i]>255))
      return(0);
  return(1);
}

function is_a_net($var)
{
    if (preg_match('/^$/',$var))
      return(1);
    if (preg_match('/^(?:\! |)\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}(?:|\/\d{1,3}(?:|\.\d{1,3}\.\d{1,3}\.\d{1,3}))$/',$var))
      return(1);
    return(0);
}

function check_name($name)
{
  if (!isset($name))
    return(1);
  if (!preg_match('/^[\w\.\-\s]+$/',$name))
    return(0);
  return(1);
}

function check_comment($name)
{
  if (!preg_match('/^[\w\.\-\s]+$/',$name))
    return(0);
  return(1);
}

function check_nb($nb)
{
  if (!isset($nb))
    return(1);
  if (!preg_match('/^[0-9]*$/',$nb))
    return(0);
  return(1);
}

function is_empty($var)
{
  if (!isset($var))
    return(1);
  if (preg_match('/^$/',$var))
    return(1);
  return(0);
}

function check_filename($filename)
{
  if (!isset($filename))
    return(1);
  if (preg_match('/\.\./',$filename))
    return(0);
  if (!preg_match('/^[\w\.\-,]*$/',$filename))
    return(0);
  return(1);
}

function check_decision($decision)
{
  if (!isset($decision))
    return(1);
  if (($decision!='accept') and ($decision!='drop') and ($decision!='reject') and ($decision!='log') and ($decision!='ulog'))
  {
    return(0);
  }
  return(1);
}

function check_aclorder($order)
{
  if (!isset($order))
    return(1);
  if (!preg_match('/^[0-9|]*$/',$order))
    return(0);
  return(1);

}

?>
