<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

$types{'elt'}{'ID'}{'edit'}=0;
$types{'elt'}{'ID'}{'must'}=1;
$types{'elt'}{'ID'}{'type'}='num';

$types{'elt'}{'type'}{'edit'}=0;
$types{'elt'}{'type'}{'must'}=1;
$types{'elt'}{'type'}{'type'}='type';

$types{'elt'}{'sport'}{'edit'}=1;
$types{'elt'}{'sport'}{'must'}=0;
$types{'elt'}{'sport'}{'type'}='portrange';

$types{'elt'}{'dport'}{'edit'}=1;
$types{'elt'}{'dport'}{'must'}=0;
$types{'elt'}{'dport'}{'type'}='portrange';

$types{'elt'}{'icmptype'}{'edit'}=1;
$types{'elt'}{'icmptype'}{'must'}=0;
$types{'elt'}{'icmptype'}{'type'}='alphanum';

$types{'elt'}{'comment'}{'edit'}=1;
$types{'elt'}{'comment'}{'must'}=0;
$types{'elt'}{'comment'}{'type'}='alphanum3';

$types{'elt'}{'name'}{'edit'}=1;
$types{'elt'}{'name'}{'must'}=0;
$types{'elt'}{'name'}{'type'}='alphanum';

$types{'elt'}{'linkid'}{'edit'}=1;
$types{'elt'}{'linkid'}{'must'}=0;
$types{'elt'}{'linkid'}{'type'}='alphanum';

$types{'elt'}{'net'}{'edit'}=1;
$types{'elt'}{'net'}{'must'}=0;
$types{'elt'}{'net'}{'type'}='network';

$types{'elt'}{'mark'}{'edit'}=1;
$types{'elt'}{'mark'}{'must'}=0;
$types{'elt'}{'mark'}{'type'}='alphanum';

$types{'elt'}{'proto'}{'edit'}=1;
$types{'elt'}{'proto'}{'must'}=0;
$types{'elt'}{'proto'}{'type'}='proto';

#$types{'elt'}{'zone'}{'edit'}=1;
#$types{'elt'}{'zone'}{'must'}=1;
#$types{'elt'}{'zone'}{'type'}='zone';
$types{'elt'}{'vpn'}{'edit'}=1;
$types{'elt'}{'vpn'}{'must'}=0;
$types{'elt'}{'vpn'}{'type'}='vpn';

$types{'elt'}{'group'}{'edit'}=1;
$types{'elt'}{'group'}{'must'}=0;
$types{'elt'}{'group'}{'type'}='num';

$types{'elt'}{'ApplicationPath'}{'edit'}=1;
$types{'elt'}{'ApplicationPath'}{'must'}=0;
$types{'elt'}{'ApplicationPath'}{'type'}='fspath';

$types{'elt'}{'OSName'}{'edit'}=1;
$types{'elt'}{'OSName'}{'must'}=0;
$types{'elt'}{'OSName'}{'type'}='alphanum';

$types{'elt'}{'OSVersion'}{'edit'}=1;
$types{'elt'}{'OSVersion'}{'must'}=0;
$types{'elt'}{'OSVersion'}{'type'}='alphanum2';


$types{'ress'}{'ID'}{'edit'}=0;
$types{'ress'}{'ID'}{'must'}=1;
$types{'ress'}{'ID'}{'type'}='num';

$types{'ress'}{'name'}{'edit'}=1;
$types{'ress'}{'name'}{'must'}=0;
$types{'ress'}{'name'}{'type'}='alphanum';

$types{'ress'}{'comment'}{'edit'}=1;
$types{'ress'}{'comment'}{'must'}=0;
$types{'ress'}{'comment'}{'type'}='alphanum3';

$types{'ress'}{'operator'}{'edit'}=1;
$types{'ress'}{'operator'}{'must'}=0;
$types{'ress'}{'operator'}{'type'}='operator';

$err_bad_alphanum=-1;
$err_bad_fspath=-2;
$err_bad_alphanum2=-3;
$err_bad_network=-4;
$err_bad_alphanum3=-5;
$err_bad_num=-6;
$err_bad_portrange=-7;
$err_bad_type=-8;
$err_bad_proto=-9;
$err_bad_operator=-10;



function check_input_var($elt_type,$type,$var){
  global $types;
  global $err_bad_alphanum;
  global $err_bad_fspath;
  global $err_bad_alphanum2;
  global $err_bad_network;
  global $err_bad_alphanum3;
  global $err_bad_num;
  global $err_bad_portrange;
  global $err_bad_type;
  global $err_bad_proto;
  global $err_bad_operator;
  if ($types{$elt_type}{$type}{'type'} == 'alphanum')
    if (!preg_match("/^[a-zA-Z0-9_\-\.\s]*$/",$var))
      return($err_bad_alphanum);
  if ($types{$elt_type}{$type}{'type'} == 'fspath')
    if (!preg_match("/^[a-zA-Z0-9_\-\.\s\/\\\\:]*$/",$var))
      return($err_bad_fspath);
  if ($types{$elt_type}{$type}{'type'} == 'alphanum2')
    if (!preg_match("/^[a-zA-Z0-9_.\-\/]*$/",$var))
      return($err_bad_alphanum2);
  if ($types{$elt_type}{$type}{'type'} == 'network'){
    if (!preg_match("/^[0-9_.\/]*$/",$var))
      return($err_bad_network);
    if (!preg_match("/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}(?:|\/\d{1,2}(?:|\d{0,1}\.\d{1,3}\.\d{1,3}\.\d{1,3}))$/",$var))
      return($err_bad_network);
  }
  if ($types{$elt_type}{$type}{'type'} == 'alphanum3')
    if (!preg_match("/^[\'a-zA-Z0-9_\-\.\s\(\)=\!\?,;]*$/",$var))
      return($err_bad_alphanum3);
  if ($types{$elt_type}{$type}{'type'} == 'num')
    if (!preg_match("/^[0-9]*$/",$var))
      return($err_bad_num);
  if ($types{$elt_type}{$type}{'type'} == 'portrange')
  {
    if (!preg_match("/^[0-9]*:*[0-9]*$/",$var))
      return($err_bad_portrange);
    $tmparr=preg_split('/:/',$var);
    //print 'FOO';
    //print_r($tmparr);
    if ((isset($tmparr[0])) and ($tmparr[0]>65535))
      return($err_bad_portrange);
    if ((isset($tmparr[0])) and (isset($tmparr[1])))
    {
      if ($tmparr[1]>65535)
        return($err_bad_portrange);
      if ($tmparr[0]>$tmparr[1])
        return($err_bad_portrange);
    }

  }
  if ($types{$elt_type}{$type}{'type'} == 'type')
    if (($var!='ipv4') and ($var!='ipv6') and ($var!='nufw') and ($var!='link') and ($var!='proto') and ($var!='app'))
      return($err_bad_type);
  if ($types{$elt_type}{$type}{'type'} == 'proto')
    if (($var!='tcp') and ($var!='udp') and ($var!='icmp'))
      return($err_bad_proto);
#  if ($types{$elt_type}{$type}{'type'} == 'zone')
#    if (($var!='internal') and ($var!='external') and ($var!='vpn') and ($var!='--'))
#      return(-1);
  if ($types{$elt_type}{$type}{'type'} == 'operator')
    if (($var!='and') and ($var!='or'))
      return($err_bad_operator);
  return(0);
}

function possible_values($elt_type,$type){
  global $ress;
  if ($elt_type=='elt')
  {
    if ($type == 'type')
      return(array('ipv4','nufw','link','proto','app'));
    if ($type == 'proto')
      return(array('tcp','udp','icmp'));
    if ($type == 'open_proto')
      return(array('--','tcp','udp','icmp'));
#    if ($type == 'zone')
#      return(array('--','internal','external','vpn'));
    if ($type == 'linkid')
      return($ress);
  }elseif ($elt_type=='ress')
  {
    if ($type == 'operator')
      return(array('and','or'));
  }elseif ($elt_type=='acl')
  {
    if ($type == 'decision')
      return(array('accept','drop','reject','log','ulog'));
  }elseif ($elt_type == 'proto')
  {
    if ($type == 'icmptype')
      return(array('--','any', 'echo-reply', 'destination-unreachable', 'network-unreachable', 'host-unreachable', 'protocol-unreachable', 'port-unreachable', 'fragmentation-needed', 'source-route-failed', 'network-unknown', 'host-unknown', 'network-prohibited', 'host-prohibited', 'TOS-network-unreachable', 'TOS-host-unreachable', 'communication-prohibited', 'host-precedence-violation', 'precedence-cutoff', 'source-quench', 'redirect', 'network-redirect', 'host-redirect', 'TOS-network-redirect', 'TOS-host-redirect', 'echo-request', 'router-advertisement', 'router-solicitation', 'time-exceeded', 'ttl-zero-during-transit', 'ttl-zero-during-reassembly', 'parameter-problem', 'ip-header-bad', 'required-option-missing', 'timestamp-request', 'timestamp-reply', 'address-mask-request', 'address-mask-reply')); 
  }
  return(0);
}

function possible_fields($elt_type,$type=0){
  if ($elt_type=='elt'){
    if ($type == 'nufw')
      return(array('ID','name','group','modified','comment'));
    if ($type == 'ipv4')
      #return(array('ID','name','net','zone','mark','modified','comment'));
      return(array('ID','name','net','vpn','mark','modified','comment'));
    if ($type == 'proto')
      return(array('ID','name','proto','dport','sport','icmptype','modified','comment'));
    if ($type == 'link')
      return(array('ID','name','linkid'));
    if ($type == 'app')
      return(array('ID','name','ApplicationPath','OSName','OSVersion','modified','comment'));
  }elseif ($elt_type=='ress'){
      return(array('ID','name','modified','comment'));
  }elseif ($elt_type=='subj'){
      return(array('ID','name','operator','modified','comment'));
  }elseif ($elt_type=='apps'){
      return(array('ID','name','operator','modified','comment'));
  }
  return(0);
}

?>


