<?php
#
# Copyright(C) 2004-2006 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

require("include/function.php");
require("/etc/nuface/config.php");
require("include/messages.php");

$title='index';
$input=$_REQUEST['input_file'];
$generate=$_REQUEST['generate'];
$used_file=$_REQUEST['used_file'];
$used_desc_file=$_REQUEST['used_desc_file'];
$reload_rules=$_REQUEST['reload_rules'];
$reload_by_hand=$_REQUEST['reload_by_hand'];
$reload_rules_type=$_REQUEST['reload_rules_type'];
$xml_download=$_REQUEST['xml_download'];
$upload_file=$_REQUEST['upload_file'];
$save_and_apply=$_REQUEST['save_and_apply'];
$edw_wiz = $_REQUEST['edw_wiz'];


if (!check_filename($used_desc_file))
{
  add_log("Bad filename");
  exit(0);
}

function generate_rules($file)
{
  global $nupyf_command;
  global $manage_input;
  global $manage_output;
  global $manage_nat;
  global $nufw_rules_dir;
  global $std_rules_dir;
  global $network_desc_file;
  global $used_desc_file;
  global $network_desc_dir;
  global $datadir;
  global $mess_error;
  global $mess_ok;
  global $rules_modified;
  global $rules_dir;
  global $nupyf_ldap_file;
  global $nupyf_conf_file;
  global $desc_file;
  if ($_SESSION['modified']!=0)
          {
            add_log($rules_modified);
          }else{
	#          add_log($nupyf_command." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file.">".$rules_dir."/".$nufw_rules_file);
	#          add_log($nupyf_command." --std ".$rules_dir."/".$std_rules_file." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file);
		  $input_rules = ($manage_input == 0)? '': 'input_rules.tmp';
		  $output_rules = ($manage_output == 0)? '': 'output_rules.tmp';
		  $nat_rules = ($manage_nat == 0)? '': 'nat_rules.tmp';
		  $nupyf_args = gen_nupyf_args($nufw_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,false);
                  $desc_file="";
                  if (is_array($network_desc_file))
                  {
                    $desc_file=$used_desc_file;
                  }else{
                    $desc_file=$network_desc_file;
                  }
	          $nufw_cmd=$nupyf_command.$nupyf_args." --ulog --conf ".$network_desc_dir."/".$nupyf_conf_file." --dumpldap ".$rules_dir."/".$nupyf_ldap_file." ".$network_desc_dir."/".$desc_file." ".$datadir."/".$file." 2>&1";
		  //add_log($nufw_cmd);
	          //system($nufw_cmd,$result1);
		  $nupyf_res = report_execute($nufw_cmd,$result1);
		  //generate rescue rules
		  $nupyf_args = gen_nupyf_args($std_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,true);
		  $nupyf_cmd = $nupyf_command.$nupyf_args." --ulog $network_desc_dir/$desc_file $datadir/$file 2>&1";
		  //add_log($nupyf_cmd);
		  $nupyf_res2 = report_execute($nupyf_cmd,$result2);
	          if (($result1!=0) or ($result2!=0)){
	            add_log($mess_error);
		    add_log($nupyf_res);
		    add_log($nupyf_res2);
		  }
	          else
	          {
	            //rename($rules_dir."/".$nufw_rules_file.".tmp",$rules_dir."/".$nufw_rules_file);
	            //rename($rules_dir."/".$std_rules_file.".tmp",$rules_dir."/".$std_rules_file)
	
		    foreach(array($nufw_rules_dir,$std_rules_dir) as $the_dir){
		      rename_if_exists("$the_dir/nat_rules.tmp","$the_dir/nat_rules");
		      rename_if_exists("$the_dir/dispatch_rules.tmp","$the_dir/dispatch_rules");
		      rename_if_exists("$the_dir/forward_rules.tmp","$the_dir/forward_rules");
		      rename_if_exists("$the_dir/input_rules.tmp","$the_dir/input_rules");
		      rename_if_exists("$the_dir/output_rules.tmp","$the_dir/output_rules");
		    }
	            add_log($mess_ok);
	          }
          }
}

function f_reload_rules()
{
  global $reload_rules;
  global $reload_rules_type;
  global $sudo_command;
  global $mess_reload_rules_ok;
  global $mess_reload_rules_nok;
          if ((isset($reload_rules)) and ($reload_rules==1))
          {
            if (isset($reload_rules_type))
            {
#            add_log("$sudo_command /etc/init.d/init-firewall start 2>&1 > $datadir/problems_log");
              $farg = $reload_rules_type == 'standard'? 'nonufw': 'start';
              #print "$sudo_command /etc/init.d/init-firewall $farg 2>&1";
              //system("$sudo_command /etc/init.d/init-firewall $farg 2>&1 > $logdir/problems_log",$result);
              $ret = report_execute("$sudo_command /etc/init.d/init-firewall $farg 2>&1",$result);
            
              if ($result==0)
              {
                add_log($mess_reload_rules_ok);
              }else{
                add_log($mess_reload_rules_nok);
		add_log($ret);
              }
            }
          } 

}



if (isset($save_and_apply) and $save_and_apply==1)
{
  session_start();
  $save_to_file=$_SESSION['xml_file'];
  $document=unserialize($_SESSION['document']);
  if (isset($save_to_file))
  {
    if ($document){
      save_file($document,$save_to_file);
      add_log("File saved to $save_to_file");
      $_SESSION['modified']=0;
      generate_rules($save_to_file);
      f_reload_rules();
    }else{
      add_log($gal_load_valid_xml_file);
    }
  }else{
    add_log("Bad filename : $save_to_file");
  }
}

if (isset($upload_file) and $upload_file=='up')
{
  $uploadfile = $tmpdir ."/" . basename($_FILES['userfile']['name']);
  //add_log($_FILES['userfile']['type']);
  if(! @new policy($_FILES['userfile']['tmp_name']) || basename($_FILES['userfile']['name'],'.xml') == $_FILES['userfile']['name']
      || ($_FILES['userfile']['type'] != '' && $_FILES['userfile']['type']!='text/xml')){
    add_log($gal_load_valid_xml_file);
  }
  elseif (!(move_uploaded_file($_FILES['userfile']['tmp_name'], $uploadfile)))
  {
    add_log($mess_pb_moving_file);
    //print_r($_FILES);
    //exit(0);
  }
  elseif (file_exists($datadir."/".basename($_FILES['userfile']['name'])))
    {
      add_log ($mess_file_exists);
    }
  elseif (!copy($uploadfile, $datadir."/".basename($_FILES['userfile']['name'])))
    add_log($mess_cant_create);
  if(file_exists($uploadfile))
    unlink($uploadfile);
  if(file_exists($_FILES['userfile']['tmp_name']))
    unlink($_FILES['userfile']['tmp_name']);
}

if (!check_filename($used_file))
{
  add_log("Bad filename");
  exit(0);
}

if (isset($input))
{
  session_start();
  //read_file includes checking on filename
  $document=read_file($input);
  if (! $document){
    add_log($gal_load_valid_xml_file);
  }else{
    $_SESSION['document']=serialize($document);
    $_SESSION['modified']=0;
    $_SESSION['xml_file']=$input;
#    add_log("SESSION : ".$_SESSION['xml_file']);
    add_log($input.$mess_index_file_was_loaded);
  }
}
else{ #We don't read and write at the same time, do we?
  $output=$_GET['output_file'];
  if (isset($output))
  {
    session_start();
    $document=unserialize($_SESSION['document']);
    if ($output=='')
      if ((isset($xml_download) and ($xml_download=='on')))
      {
        header('Content-type: binary/data');
        header('Content-Disposition: attachment; filename=acls.xml');
      }
      else
        header('Content-type: text/xml');
        #print "<html><a href=\"index.php\">$gal_back_to_index</a><xmp>\n";
    $result=save_file($document,$output);
    if ($output=='')
    {
#      print "</xmp>\n";
#      print "</html>\n";
      exit(0);
    }
    if($result)
    {
      if ($output!='')
        add_log("$datadir/$output".$mess_index_file_was_saved);
        $_SESSION['modified']=0;
    }else{
      add_log($mess_index_error_while_saving."$datadir/$output");
    }
  }else{ #We don't write and delete at the same time, do we?
    $delete=$_GET['delete_file'];
    if (isset($delete))
    {
      if(del_file($delete))
      {
        add_log("$datadir/$delete".$mess_index_file_was_deleted);
      }else{
        add_log($mess_index_error_while_deleting."$datadir/$delete");
      }
    }else{
      $forget=$_REQUEST['forget'];
      session_start();
#      if(isset($forget) and ($forget==1) and (isset($used_file)) and (preg_match('^/a-zA-Z0-9\.\-\_/$',$used_file)) and (!preg_match('/\.\./',$used_file)) and (file_exists($datadir.$used_file)))
      if(isset($forget) and ($forget==1))
      {
        add_log($mess_index_forget_all);
        $document=array();
        unset($document);
        $_SESSION['document']=serialize($document);
        $_SESSION['floating_elts']=serialize($document);
        $_SESSION['modified']=0;
        unset($_SESSION['xml_file']);
      } else {
        if ((isset($generate)) and ($generate==1))
        {
          generate_rules($used_file);
#          if ($_SESSION['modified']!=0)
#          {
#            add_log($rules_modified);
#          }else{
#	#          add_log($nupyf_command." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file.">".$rules_dir."/".$nufw_rules_file);
#	#          add_log($nupyf_command." --std ".$rules_dir."/".$std_rules_file." ".$network_desc_dir."/".$network_desc_file." ".$datadir."/".$used_file);
#		  $input_rules = ($manage_input == 0)? '': 'input_rules.tmp';
#		  $output_rules = ($manage_output == 0)? '': 'output_rules.tmp';
#		  $nat_rules = ($manage_nat == 0)? '': 'nat_rules.tmp';
#		  $nupyf_args = gen_nupyf_args($nufw_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,false);
#                  $desc_file="";
#                  if (is_array($network_desc_file))
#                  {
#                    $desc_file=$used_desc_file;
#                  }else{
#                    $desc_file=$network_desc_file;
#                  }
#	          $nufw_cmd=$nupyf_command.$nupyf_args." --ulog --conf ".$network_desc_dir."/".$nupyf_conf_file." --dumpldap ".$rules_dir."/".$nupyf_ldap_file." ".$network_desc_dir."/".$desc_file." ".$datadir."/".$used_file." 2>&1";
#		  //add_log($nufw_cmd);
#	          //system($nufw_cmd,$result1);
#		  $nupyf_res = report_execute($nufw_cmd,$result1);
#		  //generate rescue rules
#		  $nupyf_args = gen_nupyf_args($std_rules_dir,'dispatch_rules.tmp','forward_rules.tmp',$input_rules,$output_rules,$nat_rules,true);
#		  $nupyf_cmd = $nupyf_command.$nupyf_args." --ulog $network_desc_dir/$desc_file $datadir/$used_file 2>&1";
#		  //add_log($nupyf_cmd);
#		  $nupyf_res2 = report_execute($nupyf_cmd,$result2);
#	          if (($result1!=0) or ($result2!=0)){
#	            add_log($mess_error);
#		    add_log($nupyf_res);
#		    add_log($nupyf_res2);
#		  }
#	          else
#	          {
#	            //rename($rules_dir."/".$nufw_rules_file.".tmp",$rules_dir."/".$nufw_rules_file);
#	            //rename($rules_dir."/".$std_rules_file.".tmp",$rules_dir."/".$std_rules_file)
#	
#		    foreach(array($nufw_rules_dir,$std_rules_dir) as $the_dir){
#		      rename_if_exists("$the_dir/nat_rules.tmp","$the_dir/nat_rules");
#		      rename_if_exists("$the_dir/dispatch_rules.tmp","$the_dir/dispatch_rules");
#		      rename_if_exists("$the_dir/forward_rules.tmp","$the_dir/forward_rules");
#		      rename_if_exists("$the_dir/input_rules.tmp","$the_dir/input_rules");
#		      rename_if_exists("$the_dir/output_rules.tmp","$the_dir/output_rules");
#		    }
#	            add_log($mess_ok);
#	          }
#          }
        }else{
          if (isset($reload_by_hand) and ($reload_by_hand==1))
          {
            f_reload_rules();
          }
#          if ((isset($reload_rules)) and ($reload_rules==1))
#          {
#            if (isset($reload_rules_type))
#            {
##            add_log("$sudo_command /etc/init.d/init-firewall start 2>&1 > $datadir/problems_log");
#              $farg = $reload_rules_type == 'standard'? 'nonufw': 'start';
#              #print "$sudo_command /etc/init.d/init-firewall $farg 2>&1";
#              //system("$sudo_command /etc/init.d/init-firewall $farg 2>&1 > $logdir/problems_log",$result);
#              $ret = report_execute("$sudo_command /etc/init.d/init-firewall $farg 2>&1",$result);
#            
#              if ($result==0)
#              {
#                add_log($mess_reload_rules_ok);
#              }else{
#                add_log($mess_reload_rules_nok);
#		add_log($ret);
#              }
#            }
#          } 
        }
      }
    }
  }
}

$files=file_list();
require("include/headers.php");
if(isset($edw_wiz) && $edw_wiz==4){
    echo "<script type=\"text/javascript\">
    window.onload = function(){
        hide_all();
        montre_global('top','top1');
        montre('action1');
    }
    
    </script>";
    add_log("Vous pouvez choisir un fichier et recharger les rgles");
}
?>
<div class="menu">
<a href="#"><h2 onclick="javascript:montre_global('top','top1')"><?php echo $mess_files;?></h2></a>
<div class="level1" id="top1">
<?php
  print "<div class=menucat> \n<a href='#'
  onclick=\"javascript:montre('action1');\"><h3>$mess_index_load_conf_from_file</h3></a>";
$expolicy=unserialize($_SESSION['document']);
if ((!isset($expolicy)) or ($expolicy=='')){
  print "<div class='action' id='action1'>\n<form action=\"index.php\" method=POST>\n";
  print " <select name=\"input_file\">\n";
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
  print "</select>";
  print "<INPUT type=\"submit\" value=\"$mess_index_button_open\" class=\"button\">";
  print "</form></div>";
}else{
  print $mess_index_file_already_loaded;
}
print "</div>";
print "<div class=menucat >";
if ((isset($expolicy)) and ($expolicy!='')){
  print "<a  href='#' onclick=\"javascript:montre('action2');\"  ><h3>$mess_index_save_conf_to_file</h3></a>";

  echo "<div class='action' id='action2'><form><select name=\"output_file\">";
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
  echo " </select>";
  print " <INPUT type=\"submit\" value=\"$mess_index_button_overwrite\" class=\"button\">";
  ?>
  </form>
  </div>
  </div>
  <div class=menucat >
  <a  href='#' onclick="javascript:montre('action7');"  ><h3><?php echo $mess_index_save_new_file; ?></h3></a>
  <div class='action' id='action7'>
  <form action="index.php">
    <input type="text" name="output_file">
  
  <?php
  print "  <input type=\"submit\" value=\"".$mess_index_button_new."\" class=\"button\">";
  echo "</form></div>";
}
?>
</div>

<div class=menucat >
<a  href='#' onclick="javascript:montre('action9');"   ><h3><?php echo $mess_index_upload_file ?></h3></a>

<div class='action' id='action9'>

<form enctype="multipart/form-data" action="index.php" method="post">
<input type="hidden" name="upload_file" value="up"/>
<input type="hidden" name="MAX_FILE_SIZE" value="300000" />
<?php echo $mess_send_file; ?> <input name="userfile" type="file" />
<input type="submit" value="<?php echo $mess_send_file;?>" />
</form>

</div>

</div>

<div class='menucat' ><a  href='#'>
<?php
print "<h3  onclick=\"javascript:montre('action5');\"   >$mess_index_delete_a_saved_file</h3></a>";
?>
<div class='action' id='action5'>
<?php
echo "<form onsubmit=\"return confirm('$mess_index_confirm_deletion');\">";
?>
 <select name="delete_file">
<?php
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
?>
 </select>
<?php
print "<INPUT type=\"submit\" value=\"$mess_index_button_delete\" class=\"button\">";

 //echo '<br />'.$mess_index_confirm_deletion.'<input type="checkbox" id="confirm_delete" name="confirm_delete"/>';
echo "</form></div>";
?>

</div>
</div>


<a href="#"><h2 onclick="javascript:montre_global('top','top2')"><?php echo $mess_rules;?></h2></a>
<div class='level1' id='top2'>
<div class='menucat'>
<a href='#'  onclick="javascript:montre('action3');" >
<h3  ><?php print "$mess_title_rules"; ?></h3>
</a>
<div class='action' id='action3'>
<form action="index.php" method=POST>
  <input type="hidden" name=generate value=1>
 <select name="used_file">";
<?php
    if (!isset($files))
    {
      $files=array();
    }
    foreach($files as $file){
      echo "    <option>$file</option>\n";      
    }
print "</select>";
if (is_array($network_desc_file))
{
  print "<br>$mess_desc_file_choice";
  print " <select name=\"used_desc_file\">";
  foreach($network_desc_file as $file){
      echo "    <option>$file</option>\n";      
  }
  print "</select>";
}
print "  <input type=\"submit\" value=\"$mess_index_generate_rules\" class=\"button\">";
?>
</form>
</div>

</div>
<div class='menucat'  ><a  href='#'  onclick="javascript:montre('action4');"  >
<?php
print "<h3>$mess_reload_rules</h3></a>";
?>
<div class='action' id='action4'><form>
<input type=hidden name=reload_by_hand value=1>
<select name="reload_rules_type" >
 <option>nufw</option>
<option>standard</option>
</select>
<?php
print "<input type=\"submit\" value=\"$mess_reload_rules\" class=\"button\">";
?>
<input type="hidden" value="1" name="reload_rules">
</form>
</div>
</div>
</div>

<?php
if ((isset($expolicy)) and ($expolicy!='')){
?>
<a href="#"><h2 onclick="javascript:montre_global('top','top3')"><?php echo $mess_session;?></h2></a>
<div class="level1" id="top3">
<div class=menucat >
<a  href='#' onclick="javascript:montre('action8');"   ><h3><?php echo $mess_index_get_session; ?></h3></a>
<div class='action' id='action8'> <form>
<?php
echo "  <input type=hidden name=\"output_file\" value=\"\">";
print "  <input type=\"submit\" value=\"$mess_index_button_dump_on_screen\" class=\"button\">";
print " <input type=\"checkbox\" name=\"xml_download\">$mess_save_to_file";
?>

</form>
</div>
</div>


<div class='menucat' >
<a  href='#'  onclick="javascript:montre('action6');"  >
<?php
print "<h3>$mess_index_forget_this_session</h3>";
?>
</a>
<div class='action' id='action6'>
<?php
  print $mess_index_all_changes_discarded;
  print "<form action=\"index.php\" method=POST>";
  print "<input type=\"hidden\" name=\"forget\" value=\"1\">";
  print "<input type=\"submit\" value=\"$mess_index_button_forget_all\" class=\"button\">";
  print "</form>";
}
?>
</div>
</div>
</div>
</div>
<?php
begin_content_detail();
if ((isset($expolicy)) and ($expolicy!='')){
?>
  <FORM action="index.php" method="post">
    <input type="hidden" name="save_and_apply" value="1">
<?php
if (is_array($network_desc_file))
{
  print "<br>$mess_desc_file_choice";
  print " <select name=\"used_desc_file\">";
  foreach($network_desc_file as $file){
      echo "    <option>$file</option>\n";      
  }
  print "</select>";
}
?>
<input type=hidden name="reload_rules" value="1">
<select name="reload_rules_type" >
 <option>nufw</option>
<option>standard</option>
</select>
<?php
print "<input type=\"submit\" value=\"$mess_reload_rules\" class=\"button\">";

}
echo "</form>";

end_content_detail();
require("include/footer.php");
?>
