<?php
#
# Copyright(C) 2004-2005 INL
# Written by Eric Leblond <regit@inl.fr>
#            Vincent Deffontaines <gryzor@inl.fr>
#	     Jean Gillaux <jean@inl.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, version 2 of the License.
#
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

session_start();

$title='nat';
$singtitle='nat';
require("/etc/nuface/config.php");
require("include/messages.php");
$header_onclick = "return ask_list_change(new Array('sortsnat','sortdnat','sortpnat'),'$gal_confirm_change_order')";
require("include/headers.php");
require("include/function.php");
require("include/types.php");

$expolicy=unserialize($_SESSION['document']);
if ((!isset($expolicy)) or ($expolicy=='')){
  add_log($gal_load_valid_xml_file);
  log_and_exit(-1);
}

$snats=&$expolicy->snats;
$dnats=&$expolicy->dnats;
$pnats=&$expolicy->pnats;

$dndSortSnat = $_REQUEST['dndSortSnat'];
$dndSortDnat = $_REQUEST['dndSortDnat'];
$dndSortPnat = $_REQUEST['dndSortPnat'];


$nat_type=$_REQUEST['nat_type'];
$new_nat=$_REQUEST['new_nat'];
$ch_nat=$_REQUEST['nat'];
$ch_name=$_REQUEST['ch_name'];
$nat_nb=$_REQUEST['nat_nb'];
$ch_proto=$_REQUEST['proto'];
$ch_srcnet=$_REQUEST['srcnet'];
$ch_dstnet=$_REQUEST['dstnet'];
$ch_sport=$_REQUEST['sport'];
$ch_dport=$_REQUEST['dport'];
$ch_icmptype=$_REQUEST['icmptype'];
$ch_nat_addr=$_REQUEST['nat_addr'];
$ch_nat_port=$_REQUEST['nat_port'];
$delete_s=$_REQUEST['delete_s'];
$ch_comment=$_REQUEST['comment'];

#Security filtering
if (!check_aclorder($dndSortSnat))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
if (!check_aclorder($dndSortDnat))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
if (!check_aclorder($dndSortPnat))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
if (!check_nb($ch_nat))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
if (!check_nb($ch_sport))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}
if (!check_nb($ch_dport))
{
    add_log($gal_bad_param);
    log_and_exit(-1);
}




if (!isset($ch_icmptype))
  $ch_icmptype = '--';


if(isset($delete_s))//delete nat rule?
{
  if (check_input_var('elt','ID',$delete_s))
  {
      add_log($gal_bad_param_specified.'snat ID');
      log_and_exit(-1);
  }
  switch($nat_type){
      case "DNAT":
          $dnats->del_elt($delete_s);
          $dnats = $dnats->reorder();
          break;
      case "SNAT":
          $snats->del_elt($delete_s);
          $dnats = $snats->reorder();
          break;
      case "PNAT":
          $pnats->del_elt($delete_s);
          $dnats = $pnats->reorder();
          break;
      default:
        break;
  }

  $snat_ress = &$snats->ordered_list_tab();
  $dnat_ress = &$dnats->ordered_list_tab();
  $pnat_ress = &$pnats->ordered_list_tab();
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}else
if (isset($new_nat))
{
  if (isset($nat_type))
  {
    if ($nat_type != 'SNAT' and $nat_type != 'DNAT' and $nat_type != 'PNAT')
    {
      add_log($gal_bad_param_specified.'nat type');
      log_and_exit(-1);
    }
  } else {
    add_log($gal_elt_not_exists." nat type");
    log_and_exit(-1);
  }
  $ret=check_input_var('ress','name',$new_nat);
  if ($ret!=0)
  {
    add_log($gal_bad_param);
    add_log($mess_bad_input_var{$ret});
    log_and_exit(-1);
  }
  #Creating new NAT rule now.
  if ($nat_type == 'SNAT')
  {
    $new_snat{'name'}=$new_nat;
    $new=new nat($new_snat,'data',$snats->new_id());
    $snats->add_elt($new);
    $_SESSION['document']=serialize($expolicy);
    $_SESSION['modified']=1;
  }else if ($nat_type == 'DNAT')
  {
    $new_dnat{'name'}=$new_nat;
    $new=new nat($new_dnat,'data',$dnats->new_id());
    $dnats->add_elt($new);
    $_SESSION['document']=serialize($expolicy);
    $_SESSION['modified']=1;
  }else if ($nat_type == 'PNAT')
  {
    $new_pnat{'name'}=$new_nat;
    $new=new nat($new_pnat,'data',$pnats->new_id());
    $pnats->add_elt($new);
    $_SESSION['document']=serialize($expolicy);
    $_SESSION['modified']=1;
  }
  
}else
if (isset($ch_nat) and isset($ch_name) and isset($nat_nb) and isset($ch_proto))
{
  if (!isset ($nat_type))
  {
    add_log($mess_bad_input_var{"nat type"});
    log_and_exit(-1);
  }
  if ($nat_type == 'SNAT')
  {
    $tmp=$snats->get_elt($ch_nat);
  }else if ($nat_type == 'DNAT')
  {
    $tmp=$dnats->get_elt($ch_nat);
  }else if ($nat_type == 'PNAT')
  {
    $tmp=$pnats->get_elt($ch_nat);
  }else{
    add_log($gal_bad_param);
    log_and_exit(-1);
  }
  if (!isset($tmp))
  {
    add_log($gal_elt_not_exists." nat".$ch_nat);
    log_and_exit(-1);
  }
  $possible_protos=possible_values('elt','open_proto');
  $match=0;
  foreach ($possible_protos as $possible)
  {
    if ($possible == $ch_proto)
    {
      $match++;
      break;
    }
  }
  if ($match == 0)
  {
    add_log($gal_bad_param_specified."proto)");
    log_and_exit(-1);
  }
  $possible_icmptypes=possible_values('proto','icmptype');
  $match=0;
  foreach ($possible_icmptypes as $possible)
  {
    if ($possible == $ch_icmptype)
    {
      $match++;
      break;
    }
  }
  if ($match == 0)
  {
    add_log($gal_bad_param_specified."icmp type)");
    log_and_exit(-1);
  }
  if (!is_a_net($ch_srcnet))
  {
    add_log($gal_bad_param_specified."srcnet)");
    log_and_exit(-1);
  }
  if (!is_a_net($ch_dstnet))
  {
    add_log($gal_bad_param_specified."dstnet)");
    log_and_exit(-1);
  }
  if (!check_ip($ch_nat_addr))
  {
    unset($ch_nat_addr);
    if (check_input_var('ress','ID',$ch_nat_port))
    {
      add_log($gal_bad_param_specified."nat addr/nat port )");
      log_and_exit(-1);
    }
#  }else{
#    unset($ch_nat_port);
  }
  $ret=check_input_var('ress','comment',$ch_comment);
  if ($ret!=0)
  {
      add_log($gal_bad_param_specified."comment)");
      add_log($mess_bad_input_var{$ret});
      log_and_exit(-1);
  }
  $ret=check_input_var('ress','name',$ch_name);
  if ($ret!=0)
  {
      add_log($gal_bad_param_specified."name)");
      add_log($mess_bad_input_var{$ret});
      log_and_exit(-1);
  }
  if ($nat_type == 'SNAT')
  {
    #Source NAT should be set
    if (is_empty($ch_srcnet))
    {
      add_log($gal_missing_param_specified."src net)");
      log_and_exit(-1);
    }
  }
  if ($nat_type == 'DNAT')
  {
    #Source NAT should be set
    if (is_empty($ch_dstnet))
    {
      add_log($gal_missing_param_specified."dst net)");
      log_and_exit(-1);
    }
  }
  unset($received);
  $seen_mod=0;
  if ($nat_type == 'SNAT')
  {
    $my_nat=&$snats->get_elt_by_id($ch_nat);
  }else if ($nat_type == 'DNAT')
  {
    $my_nat=&$dnats->get_elt_by_id($ch_nat);
  }else{
    $my_nat=&$pnats->get_elt_by_id($ch_nat);
  }
  $received['ID']=$my_nat->ID;
  $received['srcnet']=$ch_srcnet;
  if ($ch_srcnet!=$my_nat->srcnet)
    $seen_mod++;
  $received['dstnet']=$ch_dstnet;
  if ($ch_dstnet!=$my_nat->dstnet)
    $seen_mod++;
  $received['proto']=$ch_proto;
  if ($received['proto']!=$my_nat->proto)
    $seen_mod++;
  $received['icmptype']=$ch_icmptype;
  if ($ch_icmptype!=$my_nat->icmptype)
    $seen_mod++;
  $received['comment']=$ch_comment;
  if ($ch_comment!=$my_acl->comment)
    $seen_mod++;
  $received['name']=$ch_name;
  if ($ch_name!=$my_nat->name)
    $seen_mod++;
  $received['sport']=$ch_sport;
  if ($ch_sport!=$my_nat->sport)
    $seen_mod++;
  $received['dport']=$ch_dport;
  if ($ch_dport!=$my_nat->dport)
    $seen_mod++;
  if (isset($ch_nat_addr))
  {
    $received['rewritetoaddr']=$ch_nat_addr;
    if ($ch_nat_addr != $my_nat->rewritetoaddr)
      $seen_mod++;
  }
  if (isset($ch_nat_port))
  {
    $received['rewritetoport']=$ch_nat_port;
    if ($ch_nat_port != $my_nat->rewritetoport)
      $seen_mod++;
  }
  $received['modified']=$my_nat->modified;
  if ($seen_mod)
    $received['modified']=date("D d M Y");
  $new_nat=new nat($received,'data',$my_nat->ID);
  if ($nat_type == 'SNAT')
  {
    $snats->del_elt($my_nat->ID);
    $snats->add_elt($new_nat);
  }else if ($nat_type == 'DNAT')
  {
    $dnats->del_elt($my_nat->ID);
    $dnats->add_elt($new_nat);
  }else{
    $pnats->del_elt($my_nat->ID);
    $pnats->add_elt($new_nat);
  }
  $_SESSION['document']=serialize($expolicy);
  $_SESSION['modified']=1;
}


function set_order($dndsort, $elts, &$ch_acl){
    $aclorder = $dndsort;
    $acls = $elts;
if (isset($aclorder))
{
  $tab=array();
  $tab2=array();
  $hacls=array();
  foreach($acls->elts as $eid => $elt){
    //print_r($eid);
    //print_r($elt);
    $tid=$elt->ID;
    $tab[$eid]=$elt->ID;
    $tab2[$tid]=$elt->cloneobj();
  }
  $acls2=$acls;
  $done = false;
  foreach (explode('|',$aclorder) as $k => $v) {
    $acltmpx=$tab2[$v];
    $oldid = $acltmpx->ID;
    $acltmp=$acltmpx->cloneobj();
    $acltmp->ID=$k+1; //we don't want 0 as ID
    $hacls[$k+1]=$acltmp;
    if($ch_acl==$oldid && !$done){
      $newid = $acltmp->ID;
      $ch_acl = $newid;
      //print "changing $oldid to $newid\n";
      $done = true;
    }
  }
  $newacls=new obj_set($hacls);
  $acls=$newacls;
  return $acls;
  
}
}
/* save modified order */
$ch_nat_tmp = $ch_nat;
if($dndSortSnat){
$snats2 = set_order($dndSortSnat, $snats,$ch_nat_tmp);
if($nat_type=="SNAT"){
    $ch_nat = $ch_nat_tmp;
}
$snats=$snats2;
$expolicy->snats = $snats;
$_SESSION['modified']=1;
}

if($dndSortDnat){
$dnats2 = set_order($dndSortDnat, $dnats,$ch_nat_tmp);
if($nat_type=="DNAT"){
    $ch_nat = $ch_nat_tmp;
}
$dnats=$dnats2;
$expolicy->dnats = $dnats;
$_SESSION['modified']=1;
}
if($dndSortPnat){
$pnats2 = set_order($dndSortPnat, $pnats,$ch_nat_tmp);
if($nat_type=="PNAT"){
    $ch_nat = $ch_nat_tmp;
}
$pnats=$pnats2;
$expolicy->pnats = $pnats;
$_SESSION['modified']=1;
}
if($dndSortDnat or $dndSortPnat or $dndSortSnat){
    $_SESSION['document']=serialize($expolicy);
}

$snat_ress = &$snats->ordered_list_tab();
$dnat_ress = &$dnats->ordered_list_tab();
$pnat_ress = &$pnats->ordered_list_tab();


/* Page DISPLAY */
$nat_menu_class = "aclmenu_ext";
echo "<div class=\"$nat_menu_class\">\n";
//print "<table>\n";
//echo '<form onsubmit="natHandle()" action="acls.php" method="post">';
echo '<form onsubmit="natHandle()" action="nat.php" method="post">'."\n";
echo '<p><input type="hidden" id="dndSortSnat" name="dndSortSnat" value="" />'.
'<input type="hidden" id="dndSortDnat" name="dndSortDnat" value="" />'.
'<input type="hidden" id="dndSortPnat" name="dndSortPnat" value="" />'.
        '<input type="submit" class="submit" value="'.$gal_save_nat_order.'"  />'.
	//'<input class="inspector" type="button" value="Inspect" onclick="junkdrawer.inspectListOrder(\'sortcat\')"/>'.
	'&nbsp<input class="inspector" type="button" value="'.$gal_initial_nat_order.'" onclick="resetOrder(\'sortsnat\'); resetOrder(\'sortdnat\'); resetOrder(\'sortpnat\');"/></p>'.
        '</form>';
echo "SNAT";
echo '<ul id="sortsnat" class="sortul">'."\n";
if (!isset($snat_ress))
{
  $snat_ress=array();
}
foreach ($snat_ress as $id=>$desc)
{
    $d_snat = $snats->get_elt_by_id($id);
  //if(!isset($aclorder))
    //$dacl = $acls->get_elt($id);
  $src_net = $d_snat->srcnet;
  $dst_net=$d_snat->dstnet;
  $proto=$d_snat->proto;
  $sport=$d_snat->sport;
  $dport=$d_snat->dport;
  $icmptype=$d_snat->icmptype;
  $name = $d_snat->name;
  $idp = sprintf("[%03s]",$id);
  $rewrite_addr = $d_snat->rewritetoaddr;
  $detail_form='<form action="nat.php" method="post" class="acldetail" onsubmit="natHandle()">'.
  '<input type="hidden" name="nat" value="'.$id.'" />'.
  '<input type="hidden" id="dndSortSnat" name="dndSortSnat" value="" />'.
  '<input type="hidden" name="nat_type" value="SNAT" />'.
  '<input type="submit" value="Detail" class="input1 '.$class_dec.'" title="'.$class_dec.'"/>'.
  '</form>';
    print "  <li id=\"$id\"><div class=\"sort\"  id=\"$id\"><strong>$idp</strong> $desc</div>";
  print"$detail_form</li>\n";
}
echo "</ul>\n";

echo "DNAT";
echo '<ul id="sortdnat" class="sortul">'."\n";

if (!isset($dnat_ress))
{
  $dnat_ress=array();
}
foreach ($dnat_ress as $id=>$desc)
{
  $d_dnat = $dnats->get_elt_by_id($id);
  $src_net = $d_dnat->srcnet;
  $dst_net=$d_dnat->dstnet;
  $proto=$d_dnat->proto;
  $sport=$d_dnat->sport;
  $dport=$d_dnat->dport;
  $icmptype=$d_dnat->icmptype;
  $name = $d_dnat->name;
  $idp = sprintf("[%03s]",$id);
  $rewrite_addr = $d_dnat->rewritetoaddr;
  $rewrite_port = $d_dnat->rewritetoport;
  $detail_form='<form action="nat.php" method="post" class="acldetail" onsubmit="natHandle()">'.
  '<input type="hidden" name="nat" value="'.$id.'" />'.
  '<input type="hidden" id="dndSortDnat" name="dndSortDnat" value="" />'.
  '<input type="hidden" name="nat_type" value="DNAT" />'.
  '<input type="submit" value="Detail" class="input1 '.$class_dec.'" title="'.$class_dec.'"/>'.
  '</form>';
    print "  <li id=\"$id\"><div class=\"sort\"  id=\"$id\"><strong>$idp</strong> $desc</div>";
  print"$detail_form</li>\n";
}
echo '</ul>';
echo "PNAT";
echo '<ul id="sortpnat" class="sortul">'."\n";
if (!isset($pnat_ress))
{
  $pnat_ress=array();
}
foreach ($pnat_ress as $id=>$desc)
{
  $d_pnat = $pnats->get_elt_by_id($id);
  $src_net = $d_pnat->srcnet;
  $dst_net=$d_pnat->dstnet;
  $proto=$d_pnat->proto;
  $sport=$d_pnat->sport;
  $dport=$d_pnat->dport;
  $icmptype=$d_pnat->icmptype;
  $name = $d_pnat->name;
  $idp = sprintf("[%03s]",$id);
  $rewrite_port = $d_snat->rewritetoport;
  $detail_form='<form action="nat.php" method="post" class="acldetail" onsubmit="natHandle()">'.
  '<input type="hidden" name="nat" value="'.$id.'" />'.
  '<input type="hidden" id="dndSortPnat" name="dndSortPnat" value="" />'.
  '<input type="hidden" name="nat_type" value="PNAT" />'.
  '<input type="submit" value="Detail" class="input1 '.$class_dec.'" title="'.$class_dec.'"/>'.
  '</form>';
    print "  <li id=\"$id\"><div class=\"sort\"  id=\"$id\"><strong>$idp</strong> $desc</div>";
  print"$detail_form</li>\n";
}
//print "</table>\n";
echo '</ul>';
echo '<form onsubmit="natHandle()" action="nat.php" method="post">'."\n";
echo '<p><input type="hidden" name="dndSortSnat" value="" />'.
'<input type="hidden" name="dndSortDnat" value="" />'.
'<input type="hidden" name="dndSortPnat" value="" />'.
        '<input type="submit" class="submit" value="'.$gal_save_acl_order.'" />'.
	'&nbsp<input class="inspector" type="button" value="'.$gal_initial_nat_order.'" onclick="resetOrder(\'sortsnat\'); resetOrder(\'sortdnat\'); resetOrder(\'sortpnat\');"/></p>'.
        '</form>';
print "\n</div>\n";

begin_content_detail();
if (isset($ch_nat)){
  $nat = $ch_nat;
  print "<div class=\"acledit_tab\">";
  if ($nat_type == 'SNAT')
  {
    $nats=$expolicy->snats;
  }else if ($nat_type == 'DNAT')
  {
    $nats=$expolicy->dnats;
  }else if ($nat_type == 'PNAT')
  {
    $nats=$expolicy->pnats;
  }else
  { 
    exit(-1);
  }
  $my_nat=$nats->get_elt_by_id($nat);
  if(!isset($snatorder))
    $my_nat = $nats->get_elt($nat);
    
#  print_r($my_acl);
  print "<h3>[".$my_nat->ID." ".$nat_type."] ".$my_nat->name."</h3>\n";
  $srcnet=$my_nat->srcnet;
  $dstnet=$my_nat->dstnet;
  $proto=$my_nat->proto;
  $sport=$my_nat->sport;
  $dport=$my_nat->dport;
  $icmptype=$my_nat->icmptype;
  $rewritetoaddr=$my_nat->rewritetoaddr;
  $rewritetoport=$my_nat->rewritetoport;

  $rewritetovar = $rewritetoaddr;
  if ($nat_type == 'PNAT')
    $rewritetovar = $rewritetoport;
  if ($nat_type == 'DNAT')
    $rewritetovar = $rewritetoaddr.":".$rewritetoport;

  print "<form method=\"post\" action=\"nat.php\" onsubmit=\"natHandle()\" name=\"natproto\"><input type=\"text\" style=\"width:100%\" name=\"ch_name\" value=\"".$my_nat->name."\"><input type=hidden name=nat_nb value=".$my_nat->ID."><input type=hidden name=nat_type value=".$nat_type.">";
  echo '<input type="hidden" name="dndSort" value="" />';
  //print "<input type=submit value=\"$gal_new_value\" class=\"button\">";
  //print "</form>";
#  print_r($from);
  print "<div class=\"accept\">[".$proto." ".$sport."->".$dport."]"."(".$srcnet."=>".$dstnet.") =>".$rewritetovar."</div>\n";
  //print "<form method=\"post\" action=\"acls.php\" onsubmit=\"natHandle()\">\n";
  print "<input type=hidden name=nat value=\"$nat\">\n";

  print "<table class=\"nat_edit\"><tr><td class=\"rowtitle\">$string_sourceaddr</td><td><input name=srcnet value=\"$srcnet\"></td></tr>\n";
  print "<tr><td class=\"rowtitle\">$string_destaddr</td><td><input name=dstnet value=\"$dstnet\"></td></tr>\n";

  print "<tr><td class=\"rowtitle\">$string_protocol</td><td><select name=proto onFocus=\"griser_natproto();\" onChange=\"griser_natproto();\">"; 
  $array_protos=possible_values('elt','open_proto');
  sort($array_protos);
  foreach ($array_protos as $_proto)
  {
    print "<option value=\"$_proto\"";
    if ($_proto == $proto)
      echo " selected";
    print ">".$_proto."</option>";
  }
  print " </select></td></tr>\n";

  print "<tr><td class=\"rowtitle\">Sport</td><td><input name=sport value=$sport></td></tr>\n";
  print "<tr><td class=\"rowtitle\">Dport</td><td><input name=dport value=$dport></td></tr>\n";

  print "<tr><td class=\"rowtitle\">$string_icmptype</td><td> <select name=icmptype>\n";
  $array_icmptypes=possible_values('proto','icmptype');
  sort($array_icmptypes);
  foreach ($array_icmptypes as $_icmptype)
  {
      print "\n\t<option value=\"$_icmptype\"";
      if ($icmptype == $_icmptype)
        echo " selected";
      print ">".$_icmptype."</option>";
  }
  print "</select></td></tr>\n";
  $our_param = "nat_addr";
  $rewritetovar=$rewritetoaddr;
  if ($nat_type == 'SNAT')
  {
    $string_nat_mess = $string_snat_addr;
  }
  else if ($nat_type == 'DNAT')
  {
    $string_nat_mess = $string_dnat_addr;
  }
  else if ($nat_type == 'PNAT')
  {
    $string_nat_mess = $string_pnat_addr;
    $our_param="nat_port";
    $rewritetovar=$rewritetoport;
  }
  print "<tr><td class=\"rowtitle\">$string_nat_mess</td><td><input name=$our_param value=\"$rewritetovar\"></td>\n";
  if ($nat_type == 'DNAT')
  {
    print "<td>port</td><td><input name=\"nat_port\" value=\"$rewritetoport\" size=4></td>";
  }
  print "</tr>";
  print "<tr><td class=\"rowtitle\">modified</td><td>".$my_nat->modified."</td></tr>";
  print "</table>";
  print "<table><tr><td>Comment</td><td>";
  print "<textarea name=comment cols=29>";
  print $my_nat->comment;
  print "</textarea>";
  print "</td></tr></table>\n";
  print "<input type=\"submit\"  value=\"$gal_button_apply\" class=\"button\" onMouseOver=\"griser_natproto();\" />";
  echo '<input type="hidden" name="dndSort" value="" />';
  print "</form>\n";
  print "<form action=\"nat.php\" method=\"post\" >";
  print "<input type=hidden name=nat_type value=\"$nat_type\" /><input type=hidden name=delete_s value=".$my_nat->ID."><input type=submit value=\"$mess_index_button_delete\" class=\"button\" /></form>";
  print "</div>";
}
end_content_detail();
?>

<?php
require("include/footer.php");
?>
